/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.38.0-dev.20230418(8270c45a385a180a53fd8ef8e3a189b1471100ed)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/lineRange","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(U){for(var n=[],E=0,D=U.length;E<D;E++)n[E]=X[U[E]];return n};const Ee=this,Re=typeof global=="object"?global:{};var ue;(function(U){U.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}U.Environment=n})(ue||(ue={}));var ue;(function(U){class n{constructor(r,L,S){this.type=r,this.detail=L,this.timestamp=S}}U.LoaderEvent=n;class E{constructor(r){this._events=[new n(1,"",r)]}record(r,L){this._events.push(new n(r,L,U.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}U.LoaderEventRecorder=E;class D{record(r,L){}getEvents(){return[]}}D.INSTANCE=new D,U.NullLoaderEventRecorder=D})(ue||(ue={}));var ue;(function(U){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let r;for(r in D)D.hasOwnProperty(r)&&i(r,D[r])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(r,L)=>{L&&typeof L=="object"?i[r]=n.recursiveClone(L):i[r]=L}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,U.Utilities=n})(ue||(ue={}));var ue;(function(U){function n(i){if(i instanceof Error)return i;const r=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(r.stack=i.stack),r}U.ensureError=n;class E{static validateConfigurationOptions(r){function L(S){if(S.phase==="loading"){console.error('Loading "'+S.moduleId+'" failed'),console.error(S),console.error("Here are the modules that depend on it:"),console.error(S.neededBy);return}if(S.phase==="factory"){console.error('The factory function of "'+S.moduleId+'" has thrown an exception'),console.error(S),console.error("Here are the modules that depend on it:"),console.error(S.neededBy);return}}if(r=r||{},typeof r.baseUrl!="string"&&(r.baseUrl=""),typeof r.isBuild!="boolean"&&(r.isBuild=!1),typeof r.paths!="object"&&(r.paths={}),typeof r.config!="object"&&(r.config={}),typeof r.catchError>"u"&&(r.catchError=!1),typeof r.recordStats>"u"&&(r.recordStats=!1),typeof r.urlArgs!="string"&&(r.urlArgs=""),typeof r.onError!="function"&&(r.onError=L),Array.isArray(r.ignoreDuplicateModules)||(r.ignoreDuplicateModules=[]),r.baseUrl.length>0&&(U.Utilities.endsWith(r.baseUrl,"/")||(r.baseUrl+="/")),typeof r.cspNonce!="string"&&(r.cspNonce=""),typeof r.preferScriptTags>"u"&&(r.preferScriptTags=!1),r.nodeCachedData&&typeof r.nodeCachedData=="object"&&(typeof r.nodeCachedData.seed!="string"&&(r.nodeCachedData.seed="seed"),(typeof r.nodeCachedData.writeDelay!="number"||r.nodeCachedData.writeDelay<0)&&(r.nodeCachedData.writeDelay=1e3*7),!r.nodeCachedData.path||typeof r.nodeCachedData.path!="string")){const S=n(new Error("INVALID cached data configuration, 'path' MUST be set"));S.phase="configuration",r.onError(S),r.nodeCachedData=void 0}return r}static mergeConfigurationOptions(r=null,L=null){let S=U.Utilities.recursiveClone(L||{});return U.Utilities.forEachProperty(r,(d,u)=>{d==="ignoreDuplicateModules"&&typeof S.ignoreDuplicateModules<"u"?S.ignoreDuplicateModules=S.ignoreDuplicateModules.concat(u):d==="paths"&&typeof S.paths<"u"?U.Utilities.forEachProperty(u,(y,e)=>S.paths[y]=e):d==="config"&&typeof S.config<"u"?U.Utilities.forEachProperty(u,(y,e)=>S.config[y]=e):S[d]=U.Utilities.recursiveClone(u)}),E.validateConfigurationOptions(S)}}U.ConfigurationOptionsUtil=E;class D{constructor(r,L){if(this._env=r,this.options=E.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let S=this.options.nodeRequire.main.filename,d=Math.max(S.lastIndexOf("/"),S.lastIndexOf("\\"));this.options.baseUrl=S.substring(0,d+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let r=0;r<this.options.ignoreDuplicateModules.length;r++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[r]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,(r,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:r,to:L}):this.sortedPathsRules.push({from:r,to:[L]})}),this.sortedPathsRules.sort((r,L)=>L.from.length-r.from.length)}cloneAndMerge(r){return new D(this._env,E.mergeConfigurationOptions(r,this.options))}getOptionsLiteral(){return this.options}_applyPaths(r){let L;for(let S=0,d=this.sortedPathsRules.length;S<d;S++)if(L=this.sortedPathsRules[S],U.Utilities.startsWith(r,L.from)){let u=[];for(let y=0,e=L.to.length;y<e;y++)u.push(L.to[y]+r.substr(L.from.length));return u}return[r]}_addUrlArgsToUrl(r){return U.Utilities.containsQueryString(r)?r+"&"+this.options.urlArgs:r+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(r){return this.options.urlArgs?this._addUrlArgsToUrl(r):r}_addUrlArgsIfNecessaryToUrls(r){if(this.options.urlArgs)for(let L=0,S=r.length;L<S;L++)r[L]=this._addUrlArgsToUrl(r[L]);return r}moduleIdToPaths(r){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(r))return this.isBuild()?["empty:"]:["node|"+r];let L=r,S;if(!U.Utilities.endsWith(L,".js")&&!U.Utilities.isAbsolutePath(L)){S=this._applyPaths(L);for(let d=0,u=S.length;d<u;d++)this.isBuild()&&S[d]==="empty:"||(U.Utilities.isAbsolutePath(S[d])||(S[d]=this.options.baseUrl+S[d]),!U.Utilities.endsWith(S[d],".js")&&!U.Utilities.containsQueryString(S[d])&&(S[d]=S[d]+".js"))}else!U.Utilities.endsWith(L,".js")&&!U.Utilities.containsQueryString(L)&&(L=L+".js"),S=[L];return this._addUrlArgsIfNecessaryToUrls(S)}requireToUrl(r){let L=r;return U.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],U.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(r){return!!(!this.options.isBuild||U.Utilities.isAnonymousModule(r)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[r])}isDuplicateMessageIgnoredFor(r){return this.ignoreDuplicateModulesMap.hasOwnProperty(r)}getConfigForModule(r){if(this.options.config)return this.options.config[r]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(r){this.options.onError(r)}}U.Configuration=D})(ue||(ue={}));var ue;(function(U){class n{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,y,e,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:v}=u.getConfig().getOptionsLiteral();v?this._scriptLoader=new E:this._scriptLoader=new r(this._env)}else this._env.isNode?this._scriptLoader=new r(this._env):this._scriptLoader=new E;let h={callback:e,errorback:m};if(this._callbackMap.hasOwnProperty(y)){this._callbackMap[y].push(h);return}this._callbackMap[y]=[h],this._scriptLoader.load(u,y,()=>this.triggerCallback(y),v=>this.triggerErrorback(y,v))}triggerCallback(u){let y=this._callbackMap[u];delete this._callbackMap[u];for(let e=0;e<y.length;e++)y[e].callback()}triggerErrorback(u,y){let e=this._callbackMap[u];delete this._callbackMap[u];for(let m=0;m<e.length;m++)e[m].errorback(y)}}class E{attachListeners(u,y,e){let m=()=>{u.removeEventListener("load",h),u.removeEventListener("error",v)},h=b=>{m(),y()},v=b=>{m(),e(b)};u.addEventListener("load",h),u.addEventListener("error",v)}load(u,y,e,m){if(/^node\|/.test(y)){let h=u.getConfig().getOptionsLiteral(),v=L(u.getRecorder(),h.nodeRequire||U.global.nodeRequire),b=y.split("|"),C=null;try{C=v(b[1])}catch(R){m(R);return}u.enqueueDefineAnonymousModule([],()=>C),e()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,e,m);const{trustedTypesPolicy:v}=u.getConfig().getOptionsLiteral();v&&(y=v.createScriptURL(y)),h.setAttribute("src",y);const{cspNonce:b}=u.getConfig().getOptionsLiteral();b&&h.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(h)}}}function D(d){const{trustedTypesPolicy:u}=d.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(u)),this._cachedCanUseEval}load(u,y,e,m){if(/^node\|/.test(y)){const h=u.getConfig().getOptionsLiteral(),v=L(u.getRecorder(),h.nodeRequire||U.global.nodeRequire),b=y.split("|");let C=null;try{C=v(b[1])}catch(R){m(R);return}u.enqueueDefineAnonymousModule([],function(){return C}),e()}else{const{trustedTypesPolicy:h}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(y)&&y.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(y).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${y}`,(h?self.eval(h.createScript("",b)):new Function(b)).call(self),e()}).then(void 0,m);return}try{h&&(y=h.createScriptURL(y)),importScripts(y),e()}catch(b){m(b)}}}}class r{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,y){const{nodeCachedData:e}=y.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,h=u("module");function v(b){const C=b.constructor;let R=function(w){try{return b.require(w)}finally{}};return R.resolve=function(w,p){return C._resolveFilename(w,b,!1,p)},R.resolve.paths=function(w){return C._resolveLookupPaths(w,b)},R.main=process.mainModule,R.extensions=C._extensions,R.cache=C._cache,R}h.prototype._compile=function(b,C){const R=h.wrap(b.replace(/^#!.*/,"")),_=y.getRecorder(),w=m._getCachedDataPath(e,C),p={filename:C};let c;try{const N=m._fs.readFileSync(w);c=N.slice(0,16),p.cachedData=N.slice(16),_.record(60,w)}catch{_.record(61,w)}const s=new m._vm.Script(R,p),o=s.runInThisContext(p),a=m._path.dirname(C),f=v(this),l=[this.exports,f,this,C,a,process,Re,Buffer],g=o.apply(this.exports,l);return m._handleCachedData(s,R,w,!p.cachedData,y),m._verifyCachedData(s,R,w,c,y),g}}load(u,y,e,m){const h=u.getConfig().getOptionsLiteral(),v=L(u.getRecorder(),h.nodeRequire||U.global.nodeRequire),b=h.nodeInstrumenter||function(R){return R};this._init(v),this._initNodeRequire(v,u);let C=u.getRecorder();if(/^node\|/.test(y)){let R=y.split("|"),_=null;try{_=v(R[1])}catch(w){m(w);return}u.enqueueDefineAnonymousModule([],()=>_),e()}else{y=U.Utilities.fileUriToFilePath(this._env.isWindows,y);const R=this._path.normalize(y),_=this._getElectronRendererScriptPathOrUri(R),w=!!h.nodeCachedData,p=w?this._getCachedDataPath(h.nodeCachedData,y):void 0;this._readSourceAndCachedData(R,p,C,(c,s,o,a)=>{if(c){m(c);return}let f;s.charCodeAt(0)===r._BOM?f=r._PREFIX+s.substring(1)+r._SUFFIX:f=r._PREFIX+s+r._SUFFIX,f=b(f,R);const l={filename:_,cachedData:o},g=this._createAndEvalScript(u,f,l,e,m);this._handleCachedData(g,f,p,w&&!o,u),this._verifyCachedData(g,f,p,a,u)})}}_createAndEvalScript(u,y,e,m,h){const v=u.getRecorder();v.record(31,e.filename);const b=new this._vm.Script(y,e),C=b.runInThisContext(e),R=u.getGlobalAMDDefineFunc();let _=!1;const w=function(){return _=!0,R.apply(null,arguments)};return w.amd=R.amd,C.call(U.global,u.getGlobalAMDRequireFunc(),w,e.filename,this._path.dirname(e.filename)),v.record(32,e.filename),_?m():h(new Error(`Didn't receive define call in ${e.filename}!`)),b}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let y=u.match(/^([a-z])\:(.*)/i);return y?`file:///${(y[1].toUpperCase()+":"+y[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,y){const e=this._crypto.createHash("md5").update(y,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(y).replace(/\.js$/,"");return this._path.join(u.path,`${m}-${e}.code`)}_handleCachedData(u,y,e,m,h){u.cachedDataRejected?this._fs.unlink(e,v=>{h.getRecorder().record(62,e),this._createAndWriteCachedData(u,y,e,h),v&&h.getConfig().onError(v)}):m&&this._createAndWriteCachedData(u,y,e,h)}_createAndWriteCachedData(u,y,e,m){let h=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),v=-1,b=0,C;const R=()=>{setTimeout(()=>{C||(C=this._crypto.createHash("md5").update(y,"utf8").digest());const _=u.createCachedData();if(!(_.length===0||_.length===v||b>=5)){if(_.length<v){R();return}v=_.length,this._fs.writeFile(e,Buffer.concat([C,_]),w=>{w&&m.getConfig().onError(w),m.getRecorder().record(63,e),R()})}},h*Math.pow(4,b++))};R()}_readSourceAndCachedData(u,y,e,m){if(!y)this._fs.readFile(u,{encoding:"utf8"},m);else{let h,v,b,C=2;const R=_=>{_?m(_):--C===0&&m(void 0,h,v,b)};this._fs.readFile(u,{encoding:"utf8"},(_,w)=>{h=w,R(_)}),this._fs.readFile(y,(_,w)=>{!_&&w&&w.length>0?(b=w.slice(0,16),v=w.slice(16),e.record(60,y)):e.record(61,y),R()})}}_verifyCachedData(u,y,e,m,h){m&&(u.cachedDataRejected||setTimeout(()=>{const v=this._crypto.createHash("md5").update(y,"utf8").digest();m.equals(v)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,b=>{b&&h.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}r._BOM=65279,r._PREFIX="(function (require, define, __filename, __dirname) { ",r._SUFFIX=`
});`;function L(d,u){if(u.__$__isRecorded)return u;const y=function(m){d.record(33,m);try{return u(m)}finally{d.record(34,m)}};return y.__$__isRecorded=!0,y}U.ensureRecordedNodeRequire=L;function S(d){return new n(d)}U.createScriptLoader=S})(ue||(ue={}));var ue;(function(U){class n{constructor(d){let u=d.lastIndexOf("/");u!==-1?this.fromModulePath=d.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(d){let u=d,y;for(y=/\/\.\//;y.test(u);)u=u.replace(y,"/");for(u=u.replace(/^\.\//g,""),y=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;y.test(u);)u=u.replace(y,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(d){let u=d;return U.Utilities.isAbsolutePath(u)||(U.Utilities.startsWith(u,"./")||U.Utilities.startsWith(u,"../"))&&(u=n._normalizeModuleId(this.fromModulePath+u)),u}}n.ROOT=new n(""),U.ModuleIdResolver=n;class E{constructor(d,u,y,e,m,h){this.id=d,this.strId=u,this.dependencies=y,this._callback=e,this._errorback=m,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(d,u){try{return{returnedValue:d.apply(U.global,u),producedError:null}}catch(y){return{returnedValue:null,producedError:y}}}static _invokeFactory(d,u,y,e){return d.shouldInvokeFactory(u)?d.shouldCatchError()?this._safeInvokeFunction(y,e):{returnedValue:y.apply(U.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(d,u,y,e){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){d.record(21,this.strId);let h=E._invokeFactory(u,this.strId,this._callback,y);m=h.producedError,d.record(22,this.strId),!m&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(m){let h=U.ensureError(m);h.phase="factory",h.moduleId=this.strId,h.neededBy=e(this.id),this.error=h,u.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(d){return this._isComplete=!0,this.error=d,this._errorback?(this._errorback(d),!0):!1}isComplete(){return this._isComplete}}U.Module=E;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(d){let u=this._strModuleIdToIntModuleId.get(d);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(d,u),this._intModuleIdToStrModuleId[u]=d),u}getStrModuleId(d){return this._intModuleIdToStrModuleId[d]}}class i{constructor(d){this.id=d}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),U.RegularDependency=i;class r{constructor(d,u,y){this.id=d,this.pluginId=u,this.pluginParam=y}}U.PluginDependency=r;class L{constructor(d,u,y,e,m=0){this._env=d,this._scriptLoader=u,this._loaderAvailableTimestamp=m,this._defineFunc=y,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(d,u){let y=h=>h.replace(/\\/g,"/"),e=y(d),m=u.split(/\n/);for(let h=0;h<m.length;h++){let v=m[h].match(/(.*):(\d+):(\d+)\)?$/);if(v){let b=v[1],C=v[2],R=v[3],_=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(_),b=y(b),b===e){let w={line:parseInt(C,10),col:parseInt(R,10)};return w.line===1&&(w.col-=53),w}}}throw new Error("Could not correlate define call site for needle "+d)}getBuildInfo(){if(!this._config.isBuild())return null;let d=[],u=0;for(let y=0,e=this._modules2.length;y<e;y++){let m=this._modules2[y];if(!m)continue;let h=this._buildInfoPath[m.id]||null,v=this._buildInfoDefineStack[m.id]||null,b=this._buildInfoDependencies[m.id];d[u++]={id:m.strId,path:h,defineLocation:h&&v?L._findRelevantLocationInStack(h,v):null,dependencies:b,shim:null,exports:m.exports}}return d}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(d,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let y=null;this._config.isBuild()&&(y=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:y,dependencies:d,callback:u}}defineModule(d,u,y,e,m,h=new n(d)){let v=this._moduleIdProvider.getModuleId(d);if(this._modules2[v]){this._config.isDuplicateMessageIgnoredFor(d)||console.warn("Duplicate definition of module '"+d+"'");return}let b=new E(v,d,this._normalizeDependencies(u,h),y,e,h);this._modules2[v]=b,this._config.isBuild()&&(this._buildInfoDefineStack[v]=m,this._buildInfoDependencies[v]=(b.dependencies||[]).map(C=>this._moduleIdProvider.getStrModuleId(C.id))),this._resolve(b)}_normalizeDependency(d,u){if(d==="exports")return i.EXPORTS;if(d==="module")return i.MODULE;if(d==="require")return i.REQUIRE;let y=d.indexOf("!");if(y>=0){let e=u.resolveModule(d.substr(0,y)),m=u.resolveModule(d.substr(y+1)),h=this._moduleIdProvider.getModuleId(e+"!"+m),v=this._moduleIdProvider.getModuleId(e);return new r(h,v,m)}return new i(this._moduleIdProvider.getModuleId(u.resolveModule(d)))}_normalizeDependencies(d,u){let y=[],e=0;for(let m=0,h=d.length;m<h;m++)y[e++]=this._normalizeDependency(d[m],u);return y}_relativeRequire(d,u,y,e){if(typeof u=="string")return this.synchronousRequire(u,d);this.defineModule(U.Utilities.generateAnonymousModule(),u,y,e,null,d)}synchronousRequire(d,u=new n(d)){let y=this._normalizeDependency(d,u),e=this._modules2[y.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+d+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+d+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(d,u){let y=this._config.shouldRecordStats();u?this._config=new U.Configuration(this._env,d):this._config=this._config.cloneAndMerge(d),this._config.shouldRecordStats()&&!y&&(this._recorder=null)}getConfig(){return this._config}_onLoad(d){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(d),u.dependencies,u.callback,null,u.stack)}}_createLoadError(d,u){let y=this._moduleIdProvider.getStrModuleId(d),e=(this._inverseDependencies2[d]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const m=U.ensureError(u);return m.phase="loading",m.moduleId=y,m.neededBy=e,m}_onLoadError(d,u){const y=this._createLoadError(d,u);this._modules2[d]||(this._modules2[d]=new E(d,this._moduleIdProvider.getStrModuleId(d),[],()=>{},null,null));let e=[];for(let v=0,b=this._moduleIdProvider.getMaxModuleId();v<b;v++)e[v]=!1;let m=!1,h=[];for(h.push(d),e[d]=!0;h.length>0;){let v=h.shift(),b=this._modules2[v];b&&(m=b.onDependencyError(y)||m);let C=this._inverseDependencies2[v];if(C)for(let R=0,_=C.length;R<_;R++){let w=C[R];e[w]||(h.push(w),e[w]=!0)}}m||this._config.onError(y)}_hasDependencyPath(d,u){let y=this._modules2[d];if(!y)return!1;let e=[];for(let h=0,v=this._moduleIdProvider.getMaxModuleId();h<v;h++)e[h]=!1;let m=[];for(m.push(y),e[d]=!0;m.length>0;){let v=m.shift().dependencies;if(v)for(let b=0,C=v.length;b<C;b++){let R=v[b];if(R.id===u)return!0;let _=this._modules2[R.id];_&&!e[R.id]&&(e[R.id]=!0,m.push(_))}}return!1}_findCyclePath(d,u,y){if(d===u||y===50)return[d];let e=this._modules2[d];if(!e)return null;let m=e.dependencies;if(m)for(let h=0,v=m.length;h<v;h++){let b=this._findCyclePath(m[h].id,u,y+1);if(b!==null)return b.push(d),b}return null}_createRequire(d){let u=(y,e,m)=>this._relativeRequire(d,y,e,m);return u.toUrl=y=>this._config.requireToUrl(d.resolveModule(y)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(y,e=!1)=>{this.configure(y,e)},u.__$__nodeRequire=U.global.nodeRequire,u}_loadModule(d){if(this._modules2[d]||this._knownModules2[d])return;this._knownModules2[d]=!0;let u=this._moduleIdProvider.getStrModuleId(d),y=this._config.moduleIdToPaths(u),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||e.test(u))&&y.push("node|"+u);let m=-1,h=v=>{if(m++,m>=y.length)this._onLoadError(d,v);else{let b=y[m],C=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[d]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(d),[],null,null,null),this._onLoad(d);return}C.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[d]=b),C.record(11,b),this._onLoad(d)},R=>{C.record(12,b),h(R)})}};h(null)}_loadPluginDependency(d,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let y=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],e,null,null)};y.error=e=>{this._config.onError(this._createLoadError(u.id,e))},d.load(u.pluginParam,this._createRequire(n.ROOT),y,this._config.getOptionsLiteral())}_resolve(d){let u=d.dependencies;if(u)for(let y=0,e=u.length;y<e;y++){let m=u[y];if(m===i.EXPORTS){d.exportsPassedIn=!0,d.unresolvedDependenciesCount--;continue}if(m===i.MODULE){d.unresolvedDependenciesCount--;continue}if(m===i.REQUIRE){d.unresolvedDependenciesCount--;continue}let h=this._modules2[m.id];if(h&&h.isComplete()){if(h.error){d.onDependencyError(h.error);return}d.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,d.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(d.id)+"'. The cyclic path follows:");let v=this._findCyclePath(m.id,d.id,0)||[];v.reverse(),v.push(m.id),console.warn(v.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),d.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(d.id),m instanceof r){let v=this._modules2[m.pluginId];if(v&&v.isComplete()){this._loadPluginDependency(v.exports,m);continue}let b=this._inversePluginDependencies2.get(m.pluginId);b||(b=[],this._inversePluginDependencies2.set(m.pluginId,b)),b.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}d.unresolvedDependenciesCount===0&&this._onModuleComplete(d)}_onModuleComplete(d){let u=this.getRecorder();if(d.isComplete())return;let y=d.dependencies,e=[];if(y)for(let b=0,C=y.length;b<C;b++){let R=y[b];if(R===i.EXPORTS){e[b]=d.exports;continue}if(R===i.MODULE){e[b]={id:d.strId,config:()=>this._config.getConfigForModule(d.strId)};continue}if(R===i.REQUIRE){e[b]=this._createRequire(d.moduleIdResolver);continue}let _=this._modules2[R.id];if(_){e[b]=_.exports;continue}e[b]=null}const m=b=>(this._inverseDependencies2[b]||[]).map(C=>this._moduleIdProvider.getStrModuleId(C));d.complete(u,this._config,e,m);let h=this._inverseDependencies2[d.id];if(this._inverseDependencies2[d.id]=null,h)for(let b=0,C=h.length;b<C;b++){let R=h[b],_=this._modules2[R];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let v=this._inversePluginDependencies2.get(d.id);if(v){this._inversePluginDependencies2.delete(d.id);for(let b=0,C=v.length;b<C;b++)this._loadPluginDependency(d.exports,v[b])}}}U.ModuleManager=L})(ue||(ue={}));var Y,ue;(function(U){const n=new U.Environment;let E=null;const D=function(S,d,u){typeof S!="string"&&(u=d,d=S,S=null),(typeof d!="object"||!Array.isArray(d))&&(u=d,d=null),d||(d=["require","exports","module"]),S?E.defineModule(S,d,u,null,null):E.enqueueDefineAnonymousModule(d,u)};D.amd={jQuery:!0};const i=function(S,d=!1){E.configure(S,d)},r=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};r.config=i,r.getConfig=function(){return E.getConfig().getOptionsLiteral()},r.reset=function(){E=E.reset()},r.getBuildInfo=function(){return E.getBuildInfo()},r.getStats=function(){return E.getLoaderEvents()},r.define=D;function L(){if(typeof U.global.require<"u"||typeof require<"u"){const S=U.global.require||require;if(typeof S=="function"&&typeof S.resolve=="function"){const d=U.ensureRecordedNodeRequire(E.getRecorder(),S);U.global.nodeRequire=d,r.nodeRequire=d,r.__$__nodeRequire=d}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=r:(n.isElectronRenderer||(U.global.define=D),U.global.require=r)}U.init=L,(typeof U.global.define!="function"||!U.global.define.amd)&&(E=new U.ModuleManager(n,U.createScriptLoader(n),D,r,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require<"u"&&typeof U.global.require!="function"&&r.config(U.global.require),Y=function(){return D.apply(null,arguments)},Y.amd=D.amd,typeof doNotInitLoader>"u"&&L())})(ue||(ue={}));var be=this&&this.__awaiter||function(U,n,E,D){function i(r){return r instanceof E?r:new E(function(L){L(r)})}return new(E||(E=Promise))(function(r,L){function S(y){try{u(D.next(y))}catch(e){L(e)}}function d(y){try{u(D.throw(y))}catch(e){L(e)}}function u(y){y.done?r(y.value):i(y.value).then(S,d)}u((D=D.apply(U,n||[])).next())})};Y(X[25],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(v,b){let C;return b.length===0?C=v:C=v.replace(/\{(\d+)\}/g,(R,_)=>{const w=_[0],p=b[w];let c=R;return typeof p=="string"?c=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(c=String(p)),c}),E&&(C="\uFF3B"+C.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C}function r(v,b){let C=v[b];return C||(C=v["*"],C)?C:null}function L(v){return v.charAt(v.length-1)==="/"?v:v+"/"}function S(v,b,C){return be(this,void 0,void 0,function*(){const R=L(v)+L(b)+"vscode/"+L(C),_=yield fetch(R);if(_.ok)return yield _.json();throw new Error(`${_.status} - ${_.statusText}`)})}function d(v){return function(b,C){const R=Array.prototype.slice.call(arguments,2);return i(v[b],R)}}function u(v,b,...C){return i(b,C)}n.localize=u;function y(v){}n.getConfiguredDefaultLocale=y;function e(v){E=v}n.setPseudoTranslation=e;function m(v,b){var C;return{localize:d(b[v]),getConfiguredDefaultLocale:(C=b.getConfiguredDefaultLocale)!==null&&C!==void 0?C:R=>{}}}n.create=m;function h(v,b,C,R){var _;const w=(_=R["vs/nls"])!==null&&_!==void 0?_:{};if(!v||v.length===0)return C({localize:u,getConfiguredDefaultLocale:()=>{var a;return(a=w.availableLanguages)===null||a===void 0?void 0:a["*"]}});const p=w.availableLanguages?r(w.availableLanguages,v):null,c=p===null||p===D;let s=".nls";c||(s=s+"."+p);const o=a=>{Array.isArray(a)?a.localize=d(a):a.localize=d(a[v]),a.getConfiguredDefaultLocale=()=>{var f;return(f=w.availableLanguages)===null||f===void 0?void 0:f["*"]},C(a)};typeof w.loadBundle=="function"?w.loadBundle(v,p,(a,f)=>{a?b([v+".nls"],o):o(f)}):w.translationServiceUrl&&!c?be(this,void 0,void 0,function*(){var a;try{const f=yield S(w.translationServiceUrl,p,v);return o(f)}catch(f){if(!p.includes("-"))return console.error(f),b([v+".nls"],o);try{const l=p.split("-")[0],g=yield S(w.translationServiceUrl,l,v);return(a=w.availableLanguages)!==null&&a!==void 0||(w.availableLanguages={}),w.availableLanguages["*"]=l,o(g)}catch(l){return console.error(l),b([v+".nls"],o)}}}):b([v+s],o,a=>{if(s===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${p}. Falling back to the default language:`,a),b([v+".nls"],o)})}n.load=h}),function(){var U,n;const E=globalThis.MonacoEnvironment,D=E&&E.baseUrl?E.baseUrl:"../../../",i=typeof((U=self.trustedTypes)===null||U===void 0?void 0:U.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,...m)=>{const h=m.slice(0,-1).join(","),v=m.pop().toString();return`(function anonymous(${h}) { ${v}
})`}}):void 0;function r(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function L(){return new Promise((e,m)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return e();const h=D+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(h).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${h}`,(i?globalThis.eval(i.createScript("",b)):new Function(b)).call(globalThis),e()}).then(void 0,m);return}i?importScripts(i.createScriptURL(h)):importScripts(h),e()})}function S(){require.config({baseUrl:D,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function d(e){L().then(()=>{S(),require([e],function(m){setTimeout(function(){const h=m.create((v,b)=>{globalThis.postMessage(v,b)},null);for(globalThis.onmessage=v=>h.onmessage(v.data,v.ports);y.length>0;){const v=y.shift();h.onmessage(v.data,v.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&S();let u=!0;const y=[];globalThis.onmessage=e=>{if(!u){y.push(e);return}u=!1,d(e.data)}}(),Y(X[26],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(I,T=0){return I[I.length-(1+T)]}n.tail=E;function D(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=D;function i(I,T,B=(t,H)=>t===H){if(I===T)return!0;if(!I||!T||I.length!==T.length)return!1;for(let t=0,H=I.length;t<H;t++)if(!B(I[t],T[t]))return!1;return!0}n.equals=i;function r(I,T){const B=I.length-1;T<B&&(I[T]=I[B]),I.pop()}n.removeFastWithoutKeepingOrder=r;function L(I,T,B){return S(I.length,t=>B(I[t],T))}n.binarySearch=L;function S(I,T){let B=0,t=I-1;for(;B<=t;){const H=(B+t)/2|0,oe=T(H);if(oe<0)B=H+1;else if(oe>0)t=H-1;else return H}return-(B+1)}n.binarySearch2=S;function d(I,T){let B=0,t=I.length;if(t===0)return 0;for(;B<t;){const H=Math.floor((B+t)/2);T(I[H])?t=H:B=H+1}return B}n.findFirstInSorted=d;function u(I,T,B){if(I=I|0,I>=T.length)throw new TypeError("invalid index");const t=T[Math.floor(T.length*Math.random())],H=[],oe=[],ne=[];for(const ce of T){const _e=B(ce,t);_e<0?H.push(ce):_e>0?oe.push(ce):ne.push(ce)}return I<H.length?u(I,H,B):I<H.length+ne.length?ne[0]:u(I-(H.length+ne.length),oe,B)}n.quickSelect=u;function y(I,T){const B=[];let t;for(const H of I.slice(0).sort(T))!t||T(t[0],H)!==0?(t=[H],B.push(t)):t.push(H);return B}n.groupBy=y;function e(I){return I.filter(T=>!!T)}n.coalesce=e;function m(I){let T=0;for(let B=0;B<I.length;B++)I[B]&&(I[T]=I[B],T+=1);I.length=T}n.coalesceInPlace=m;function h(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=h;function v(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=v;function b(I,T=B=>B){const B=new Set;return I.filter(t=>{const H=T(t);return B.has(H)?!1:(B.add(H),!0)})}n.distinct=b;function C(I,T){const B=R(I,T);if(B!==-1)return I[B]}n.findLast=C;function R(I,T){for(let B=I.length-1;B>=0;B--){const t=I[B];if(T(t))return B}return-1}n.lastIndex=R;function _(I,T){return I.length>0?I[0]:T}n.firstOrDefault=_;function w(I,T){let B=typeof T=="number"?I:0;typeof T=="number"?B=I:(B=0,T=I);const t=[];if(B<=T)for(let H=B;H<T;H++)t.push(H);else for(let H=B;H>T;H--)t.push(H);return t}n.range=w;function p(I,T,B){const t=I.slice(0,T),H=I.slice(T);return t.concat(B,H)}n.arrayInsert=p;function c(I,T){const B=I.indexOf(T);B>-1&&(I.splice(B,1),I.unshift(T))}n.pushToStart=c;function s(I,T){const B=I.indexOf(T);B>-1&&(I.splice(B,1),I.push(T))}n.pushToEnd=s;function o(I,T){for(const B of T)I.push(B)}n.pushMany=o;function a(I){return Array.isArray(I)?I:[I]}n.asArray=a;function f(I,T){for(const B of I){const t=T(B);if(t!==void 0)return t}}n.mapFind=f;function l(I,T,B){const t=N(I,T),H=I.length,oe=B.length;I.length=H+oe;for(let ne=H-1;ne>=t;ne--)I[ne+oe]=I[ne];for(let ne=0;ne<oe;ne++)I[ne+t]=B[ne]}n.insertInto=l;function g(I,T,B,t){const H=N(I,T),oe=I.splice(H,B);return l(I,H,t),oe}n.splice=g;function N(I,T){return T<0?Math.max(T+I.length,0):Math.min(T,I.length)}var A;(function(I){function T(H){return H<0}I.isLessThan=T;function B(H){return H>0}I.isGreaterThan=B;function t(H){return H===0}I.isNeitherLessOrGreaterThan=t,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(A=n.CompareResult||(n.CompareResult={}));function M(I,T){return(B,t)=>T(I(B),I(t))}n.compareBy=M;const k=(I,T)=>I-T;n.numberComparator=k;function q(I,T){if(I.length===0)return;let B=I[0];for(let t=1;t<I.length;t++){const H=I[t];T(H,B)>0&&(B=H)}return B}n.findMaxBy=q;function F(I,T){if(I.length===0)return;let B=I[0];for(let t=1;t<I.length;t++){const H=I[t];T(H,B)>=0&&(B=H)}return B}n.findLastMaxBy=F;function O(I,T){return q(I,(B,t)=>-T(B,t))}n.findMinBy=O;class V{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let B=this.firstIdx;for(;B<this.items.length&&T(this.items[B]);)B++;const t=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,t}takeFromEndWhile(T){let B=this.lastIdx;for(;B>=0&&T(this.items[B]);)B--;const t=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,t}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const B=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,B}}n.ArrayQueue=V;class G{constructor(T){this.iterate=T}toArray(){const T=[];return this.iterate(B=>(T.push(B),!0)),T}filter(T){return new G(B=>this.iterate(t=>T(t)?B(t):!0))}map(T){return new G(B=>this.iterate(t=>B(T(t))))}findLast(T){let B;return this.iterate(t=>(T(t)&&(B=t),!0)),B}findLastMaxBy(T){let B,t=!0;return this.iterate(H=>((t||A.isGreaterThan(T(H,B)))&&(t=!1,B=H),!0)),B}}G.empty=new G(I=>{}),n.CallbackIterable=G}),Y(X[27],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(r){this.fn=r,this.lastCache=void 0,this.lastArgKey=void 0}get(r){const L=JSON.stringify(r);return this.lastArgKey!==L&&(this.lastArgKey=L,this.lastCache=this.fn(r)),this.lastCache}}n.LRUCachedFunction=E;class D{get cachedValues(){return this._map}constructor(r){this.fn=r,this._map=new Map}get(r){if(this._map.has(r))return this._map.get(r);const L=this.fn(r);return this._map.set(r,L),L}}n.CachedFunction=D}),Y(X[28],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,r,L,S){this.originalStart=i,this.originalLength=r,this.modifiedStart=L,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),Y(X[4],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(C){setTimeout(()=>{throw C.stack?h.isErrorNoTelemetry(C)?new h(C.message+`

`+C.stack):new Error(C.message+`

`+C.stack):C},0)}}emit(C){this.listeners.forEach(R=>{R(C)})}onUnexpectedError(C){this.unexpectedErrorHandler(C),this.emit(C)}onUnexpectedExternalError(C){this.unexpectedErrorHandler(C)}}n.ErrorHandler=E,n.errorHandler=new E;function D(b){S(b)||n.errorHandler.onUnexpectedError(b)}n.onUnexpectedError=D;function i(b){S(b)||n.errorHandler.onUnexpectedExternalError(b)}n.onUnexpectedExternalError=i;function r(b){if(b instanceof Error){const{name:C,message:R}=b,_=b.stacktrace||b.stack;return{$isError:!0,name:C,message:R,stack:_,noTelemetry:h.isErrorNoTelemetry(b)}}return b}n.transformErrorForSerialization=r;const L="Canceled";function S(b){return b instanceof d?!0:b instanceof Error&&b.name===L&&b.message===L}n.isCancellationError=S;class d extends Error{constructor(){super(L),this.name=this.message}}n.CancellationError=d;function u(){const b=new Error(L);return b.name=b.message,b}n.canceled=u;function y(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}n.illegalArgument=y;function e(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}n.illegalState=e;class m extends Error{constructor(C){super("NotSupported"),C&&(this.message=C)}}n.NotSupportedError=m;class h extends Error{constructor(C){super(C),this.name="CodeExpectedError"}static fromError(C){if(C instanceof h)return C;const R=new h;return R.message=C.message,R.stack=C.stack,R}static isErrorNoTelemetry(C){return C.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class v extends Error{constructor(C){super(C||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype);debugger}}n.BugIndicatingError=v}),Y(X[10],J([0,1,4]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(S,d){if(!S)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}n.ok=D;function i(S,d="Unreachable"){throw new Error(d)}n.assertNever=i;function r(S){if(!S()){debugger;S(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=r;function L(S,d){let u=0;for(;u<S.length-1;){const y=S[u],e=S[u+1];if(!d(y,e))return!1;u++}return!0}n.checkAdjacentItems=L}),Y(X[14],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(D){const i=this;let r=!1,L;return function(){return r||(r=!0,L=D.apply(i,arguments)),L}}n.once=E}),Y(X[15],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(D){function i(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}D.is=i;const r=Object.freeze([]);function L(){return r}D.empty=L;function*S(p){yield p}D.single=S;function d(p){return i(p)?p:S(p)}D.wrap=d;function u(p){return p||r}D.from=u;function y(p){return!p||p[Symbol.iterator]().next().done===!0}D.isEmpty=y;function e(p){return p[Symbol.iterator]().next().value}D.first=e;function m(p,c){for(const s of p)if(c(s))return!0;return!1}D.some=m;function h(p,c){for(const s of p)if(c(s))return s}D.find=h;function*v(p,c){for(const s of p)c(s)&&(yield s)}D.filter=v;function*b(p,c){let s=0;for(const o of p)yield c(o,s++)}D.map=b;function*C(...p){for(const c of p)for(const s of c)yield s}D.concat=C;function R(p,c,s){let o=s;for(const a of p)o=c(o,a);return o}D.reduce=R;function*_(p,c,s=p.length){for(c<0&&(c+=p.length),s<0?s+=p.length:s>p.length&&(s=p.length);c<s;c++)yield p[c]}D.slice=_;function w(p,c=Number.POSITIVE_INFINITY){const s=[];if(c===0)return[s,p];const o=p[Symbol.iterator]();for(let a=0;a<c;a++){const f=o.next();if(f.done)return[s,D.empty()];s.push(f.value)}return[s,{[Symbol.iterator](){return o}}]}D.consume=w})(E=n.Iterable||(n.Iterable={}))}),Y(X[29],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,h){this._keyCodeToStr[m]=h,this._strToKeyCode[h.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const D=new E,i=new E,r=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const L=[],S=Object.create(null),d=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",m=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],v=[];for(const b of m){const[C,R,_,w,p,c,s,o,a,f]=b;if(v[_]||(v[_]=!0,L[_]=w,S[w]=_,d[w.toLowerCase()]=_,R&&(n.IMMUTABLE_CODE_TO_KEY_CODE[_]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[p]=_))),!h[p]){if(h[p]=!0,!c)throw new Error(`String representation missing for key code ${p} around scan code ${w}`);D.define(p,c),i.define(p,a||c),r.define(p,f||a||c)}s&&(n.EVENT_KEY_CODE_MAP[s]=p),o&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=p)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var u;(function(e){function m(_){return D.keyCodeToStr(_)}e.toString=m;function h(_){return D.strToKeyCode(_)}e.fromString=h;function v(_){return i.keyCodeToStr(_)}e.toUserSettingsUS=v;function b(_){return r.keyCodeToStr(_)}e.toUserSettingsGeneral=b;function C(_){return i.strToKeyCode(_)||r.strToKeyCode(_)}e.fromUserSettings=C;function R(_){if(_>=93&&_<=108)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(_)}e.toElectronAccelerator=R})(u=n.KeyCodeUtils||(n.KeyCodeUtils={}));function y(e,m){const h=(m&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=y}),Y(X[30],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),Y(X[11],J([0,1,14,15]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let r=null;function L(o){r=o}if(n.setDisposableTracker=L,i){const o="__is_disposable_tracked__";L(new class{trackDisposable(a){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(f)},3e3)}setParent(a,f){if(a&&a!==R.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==R.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function S(o){return r?.trackDisposable(o),o}function d(o){r?.markAsDisposed(o)}function u(o,a){r?.setParent(o,a)}function y(o,a){if(r)for(const f of o)r.setParent(f,a)}function e(o){return r?.markAsSingleton(o),o}n.markAsSingleton=e;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}n.isDisposable=m;function h(o){if(D.Iterable.is(o)){const a=[];for(const f of o)if(f)try{f.dispose()}catch(l){a.push(l)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}n.dispose=h;function v(...o){const a=b(()=>h(o));return y(o,a),a}n.combinedDisposable=v;function b(o){const a=S({dispose:(0,E.once)(()=>{d(a),o()})});return a}n.toDisposable=b;class C{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return u(a,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}C.DISABLE_DISPOSED_WARNING=!1,n.DisposableStore=C;class R{constructor(){this._store=new C,S(this),u(this._store,this)}dispose(){d(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}R.None=Object.freeze({dispose(){}}),n.Disposable=R;class _{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var f;this._isDisposed||a===this._value||((f=this._value)===null||f===void 0||f.dispose(),a&&u(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,d(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}n.MutableDisposable=_;class w{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=w;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(a){let f=a;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,d(this))},this}}n.SafeDisposable=p;class c{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=c;class s{constructor(){this._store=new Map,this._isDisposed=!1,S(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,f,l=!1){var g;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),l||(g=this._store.get(a))===null||g===void 0||g.dispose(),this._store.set(a,f)}deleteAndDispose(a){var f;(f=this._store.get(a))===null||f===void 0||f.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=s}),Y(X[16],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(r){this.element=r,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class D{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let r=this._first;for(;r!==E.Undefined;){const L=r.next;r.prev=E.Undefined,r.next=E.Undefined,r=L}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(r){return this._insert(r,!1)}push(r){return this._insert(r,!0)}_insert(r,L){const S=new E(r);if(this._first===E.Undefined)this._first=S,this._last=S;else if(L){const u=this._last;this._last=S,S.prev=u,u.next=S}else{const u=this._first;this._first=S,S.next=u,u.prev=S}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(S))}}shift(){if(this._first!==E.Undefined){const r=this._first.element;return this._remove(this._first),r}}pop(){if(this._last!==E.Undefined){const r=this._last.element;return this._remove(this._last),r}}_remove(r){if(r.prev!==E.Undefined&&r.next!==E.Undefined){const L=r.prev;L.next=r.next,r.next.prev=L}else r.prev===E.Undefined&&r.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):r.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):r.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let r=this._first;for(;r!==E.Undefined;)yield r.element,r=r.next}}n.LinkedList=D}),Y(X[5],J([0,1,27,30]),function(U,n,E,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function r(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=r;const L=/{(\d+)}/g;function S(P,...x){return x.length===0?P:P.replace(L,function(W,j){const K=parseInt(j,10);return isNaN(K)||K<0||K>=x.length?W:x[K]})}n.format=S;function d(P){return P.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}n.escape=d;function u(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=u;function y(P,x=" "){const W=e(P,x);return m(W,x)}n.trim=y;function e(P,x){if(!P||!x)return P;const W=x.length;if(W===0||P.length===0)return P;let j=0;for(;P.indexOf(x,j)===j;)j=j+W;return P.substring(j)}n.ltrim=e;function m(P,x){if(!P||!x)return P;const W=x.length,j=P.length;if(W===0||j===0)return P;let K=j,le=-1;for(;le=P.lastIndexOf(x,K-1),!(le===-1||le+W!==K);){if(le===0)return"";K=le}return P.substring(0,K)}n.rtrim=m;function h(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function v(P){return P.replace(/\*/g,"")}n.stripWildcards=v;function b(P,x,W={}){if(!P)throw new Error("Cannot create regex from empty string");x||(P=u(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return W.global&&(j+="g"),W.matchCase||(j+="i"),W.multiline&&(j+="m"),W.unicode&&(j+="u"),new RegExp(P,j)}n.createRegExp=b;function C(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=C;function R(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=R;function _(P){return P.split(/\r\n|\r|\n/)}n.splitLines=_;function w(P){for(let x=0,W=P.length;x<W;x++){const j=P.charCodeAt(x);if(j!==32&&j!==9)return x}return-1}n.firstNonWhitespaceIndex=w;function p(P,x=0,W=P.length){for(let j=x;j<W;j++){const K=P.charCodeAt(j);if(K!==32&&K!==9)return P.substring(x,j)}return P.substring(x,W)}n.getLeadingWhitespace=p;function c(P,x=P.length-1){for(let W=x;W>=0;W--){const j=P.charCodeAt(W);if(j!==32&&j!==9)return W}return-1}n.lastNonWhitespaceIndex=c;function s(P,x){return P<x?-1:P>x?1:0}n.compare=s;function o(P,x,W=0,j=P.length,K=0,le=x.length){for(;W<j&&K<le;W++,K++){const pe=P.charCodeAt(W),ae=x.charCodeAt(K);if(pe<ae)return-1;if(pe>ae)return 1}const de=j-W,ye=le-K;return de<ye?-1:de>ye?1:0}n.compareSubstring=o;function a(P,x){return f(P,x,0,P.length,0,x.length)}n.compareIgnoreCase=a;function f(P,x,W=0,j=P.length,K=0,le=x.length){for(;W<j&&K<le;W++,K++){let pe=P.charCodeAt(W),ae=x.charCodeAt(K);if(pe===ae)continue;if(pe>=128||ae>=128)return o(P.toLowerCase(),x.toLowerCase(),W,j,K,le);g(pe)&&(pe-=32),g(ae)&&(ae-=32);const ve=pe-ae;if(ve!==0)return ve}const de=j-W,ye=le-K;return de<ye?-1:de>ye?1:0}n.compareSubstringIgnoreCase=f;function l(P){return P>=48&&P<=57}n.isAsciiDigit=l;function g(P){return P>=97&&P<=122}n.isLowerAsciiLetter=g;function N(P){return P>=65&&P<=90}n.isUpperAsciiLetter=N;function A(P,x){return P.length===x.length&&f(P,x)===0}n.equalsIgnoreCase=A;function M(P,x){const W=x.length;return x.length>P.length?!1:f(P,x,0,W)===0}n.startsWithIgnoreCase=M;function k(P,x){const W=Math.min(P.length,x.length);let j;for(j=0;j<W;j++)if(P.charCodeAt(j)!==x.charCodeAt(j))return j;return W}n.commonPrefixLength=k;function q(P,x){const W=Math.min(P.length,x.length);let j;const K=P.length-1,le=x.length-1;for(j=0;j<W;j++)if(P.charCodeAt(K-j)!==x.charCodeAt(le-j))return j;return W}n.commonSuffixLength=q;function F(P){return 55296<=P&&P<=56319}n.isHighSurrogate=F;function O(P){return 56320<=P&&P<=57343}n.isLowSurrogate=O;function V(P,x){return(P-55296<<10)+(x-56320)+65536}n.computeCodePoint=V;function G(P,x,W){const j=P.charCodeAt(W);if(F(j)&&W+1<x){const K=P.charCodeAt(W+1);if(O(K))return V(j,K)}return j}n.getNextCodePoint=G;function I(P,x){const W=P.charCodeAt(x-1);if(O(W)&&x>1){const j=P.charCodeAt(x-2);if(F(j))return V(j,W)}return W}class T{get offset(){return this._offset}constructor(x,W=0){this._str=x,this._len=x.length,this._offset=W}setOffset(x){this._offset=x}prevCodePoint(){const x=I(this._str,this._offset);return this._offset-=x>=65536?2:1,x}nextCodePoint(){const x=G(this._str,this._len,this._offset);return this._offset+=x>=65536?2:1,x}eol(){return this._offset>=this._len}}n.CodePointIterator=T;class B{get offset(){return this._iterator.offset}constructor(x,W=0){this._iterator=new T(x,W)}nextGraphemeLength(){const x=te.getInstance(),W=this._iterator,j=W.offset;let K=x.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const le=W.offset,de=x.getGraphemeBreakType(W.nextCodePoint());if(ee(K,de)){W.setOffset(le);break}K=de}return W.offset-j}prevGraphemeLength(){const x=te.getInstance(),W=this._iterator,j=W.offset;let K=x.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const le=W.offset,de=x.getGraphemeBreakType(W.prevCodePoint());if(ee(de,K)){W.setOffset(le);break}K=de}return j-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=B;function t(P,x){return new B(P,x).nextGraphemeLength()}n.nextCharLength=t;function H(P,x){return new B(P,x).prevGraphemeLength()}n.prevCharLength=H;function oe(P,x){x>0&&O(P.charCodeAt(x))&&x--;const W=x+t(P,x);return[W-H(P,W),W]}n.getCharContainingOffset=oe;let ne;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(P){return ne||(ne=ce()),ne.test(P)}n.containsRTL=_e;const re=/^[\t\n\r\x20-\x7E]*$/;function se(P){return re.test(P)}n.isBasicASCII=se,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ge(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=ge;function Le(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=Le;function Z(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=Z,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function z(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=z;function Q(P,x=!1){return P?(x&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Q;function $(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=$;function ee(P,x){return P===0?x!==5&&x!==7:P===2&&x===3?!1:P===4||P===2||P===3||x===4||x===2||x===3?!0:!(P===8&&(x===8||x===9||x===11||x===12)||(P===11||P===9)&&(x===9||x===10)||(P===12||P===10)&&x===10||x===5||x===13||x===7||P===1||P===13&&x===14||P===6&&x===6)}class te{static getInstance(){return te._INSTANCE||(te._INSTANCE=new te),te._INSTANCE}constructor(){this._data=ie()}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const W=this._data,j=W.length/3;let K=1;for(;K<=j;)if(x<W[3*K])K=2*K;else if(x>W[3*K+1])K=2*K+1;else return W[3*K+2];return 0}}te._INSTANCE=null;function ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function fe(P,x){if(P===0)return 0;const W=Se(P,x);if(W!==void 0)return W;const j=new T(x,P);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=fe;function Se(P,x){const W=new T(x,P);let j=W.prevCodePoint();for(;we(j)||j===65039||j===8419;){if(W.offset===0)return;j=W.prevCodePoint()}if(!Z(j))return;let K=W.offset;return K>0&&W.prevCodePoint()===8205&&(K=W.offset),K}function we(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class he{static getInstance(x){return he.cache.get(Array.from(x))}static getLocales(){return he._locales.value}constructor(x){this.confusableDictionary=x}isAmbiguous(x){return this.confusableDictionary.has(x)}getPrimaryConfusable(x){return this.confusableDictionary.get(x)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i=he,he.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),he.cache=new E.LRUCachedFunction(P=>{function x(ae){const ve=new Map;for(let Ce=0;Ce<ae.length;Ce+=2)ve.set(ae[Ce],ae[Ce+1]);return ve}function W(ae,ve){const Ce=new Map(ae);for(const[Ae,Ne]of ve)Ce.set(Ae,Ne);return Ce}function j(ae,ve){if(!ae)return ve;const Ce=new Map;for(const[Ae,Ne]of ae)ve.has(Ae)&&Ce.set(Ae,Ne);return Ce}const K=i.ambiguousCharacterData.value;let le=P.filter(ae=>!ae.startsWith("_")&&ae in K);le.length===0&&(le=["_default"]);let de;for(const ae of le){const ve=x(K[ae]);de=j(de,ve)}const ye=x(K._common),pe=W(ye,de);return new he(pe)}),he._locales=new D.Lazy(()=>Object.keys(he.ambiguousCharacterData.value).filter(P=>!P.startsWith("_"))),n.AmbiguousCharacters=he;class me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(me.getRawData())),this._data}static isInvisibleCharacter(x){return me.getData().has(x)}static get codePoints(){return me.getData()}}me._data=void 0,n.InvisibleCharacters=me}),Y(X[31],J([0,1,5]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(b){return i(b,0)}n.hash=D;function i(b,C){switch(typeof b){case"object":return b===null?r(349,C):Array.isArray(b)?d(b,C):u(b,C);case"string":return S(b,C);case"boolean":return L(b,C);case"number":return r(b,C);case"undefined":return r(937,C);default:return r(617,C)}}n.doHash=i;function r(b,C){return(C<<5)-C+b|0}n.numberHash=r;function L(b,C){return r(b?433:863,C)}function S(b,C){C=r(149417,C);for(let R=0,_=b.length;R<_;R++)C=r(b.charCodeAt(R),C);return C}n.stringHash=S;function d(b,C){return C=r(104579,C),b.reduce((R,_)=>i(_,R),C)}function u(b,C){return C=r(181387,C),Object.keys(b).sort().reduce((R,_)=>(R=S(_,R),i(b[_],R)),C)}function y(b,C,R=32){const _=R-C,w=~((1<<_)-1);return(b<<C|(w&b)>>>_)>>>0}function e(b,C=0,R=b.byteLength,_=0){for(let w=0;w<R;w++)b[C+w]=_}function m(b,C,R="0"){for(;b.length<C;)b=R+b;return b}function h(b,C=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(R=>R.toString(16).padStart(2,"0")).join(""):m((b>>>0).toString(16),C/4)}n.toHexString=h;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const R=C.length;if(R===0)return;const _=this._buff;let w=this._buffLen,p=this._leftoverHighSurrogate,c,s;for(p!==0?(c=p,s=-1,p=0):(c=C.charCodeAt(0),s=0);;){let o=c;if(E.isHighSurrogate(c))if(s+1<R){const a=C.charCodeAt(s+1);E.isLowSurrogate(a)?(s++,o=E.computeCodePoint(c,a)):o=65533}else{p=c;break}else E.isLowSurrogate(c)&&(o=65533);if(w=this._push(_,w,o),s++,s<R)c=C.charCodeAt(s);else break}this._buffLen=w,this._leftoverHighSurrogate=p}_push(C,R,_){return _<128?C[R++]=_:_<2048?(C[R++]=192|(_&1984)>>>6,C[R++]=128|(_&63)>>>0):_<65536?(C[R++]=224|(_&61440)>>>12,C[R++]=128|(_&4032)>>>6,C[R++]=128|(_&63)>>>0):(C[R++]=240|(_&1835008)>>>18,C[R++]=128|(_&258048)>>>12,C[R++]=128|(_&4032)>>>6,C[R++]=128|(_&63)>>>0),R>=64&&(this._step(),R-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),R}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=v._bigBlock32,R=this._buffDV;for(let l=0;l<64;l+=4)C.setUint32(l,R.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)C.setUint32(l,y(C.getUint32(l-12,!1)^C.getUint32(l-32,!1)^C.getUint32(l-56,!1)^C.getUint32(l-64,!1),1),!1);let _=this._h0,w=this._h1,p=this._h2,c=this._h3,s=this._h4,o,a,f;for(let l=0;l<80;l++)l<20?(o=w&p|~w&c,a=1518500249):l<40?(o=w^p^c,a=1859775393):l<60?(o=w&p|w&c|p&c,a=2400959708):(o=w^p^c,a=3395469782),f=y(_,5)+o+s+a+C.getUint32(l*4,!1)&4294967295,s=c,c=p,p=y(w,30),w=_,_=f;this._h0=this._h0+_&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+p&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+s&4294967295}}v._bigBlock32=new DataView(new ArrayBuffer(320)),n.StringSHA1=v}),Y(X[17],J([0,1,28,31]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,m=new Int32Array(e.length);for(let h=0,v=e.length;h<v;h++)m[h]=e.charCodeAt(h);return m}}n.StringDiffSequence=i;function r(y,e,m){return new u(new i(y),new i(e)).ComputeDiff(m).changes}n.stringDiff=r;class L{static Assert(e,m){if(!e)throw new Error(m)}}class S{static Copy(e,m,h,v,b){for(let C=0;C<b;C++)h[v+C]=e[m+C]}static Copy2(e,m,h,v,b){for(let C=0;C<b;C++)h[v+C]=e[m+C]}}class d{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class u{constructor(e,m,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=m;const[v,b,C]=u._getElements(e),[R,_,w]=u._getElements(m);this._hasStrings=C&&w,this._originalStringElements=v,this._originalElementsOrHash=b,this._modifiedStringElements=R,this._modifiedElementsOrHash=_,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const m=e.getElements();if(u._isStringArray(m)){const h=new Int32Array(m.length);for(let v=0,b=m.length;v<b;v++)h[v]=(0,D.stringHash)(m[v],0);return[m,h,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(e,m){if(!this.ElementsAreEqual(e,m))return!1;const h=u._getStrictElement(this._originalSequence,e),v=u._getStrictElement(this._modifiedSequence,m);return h===v}static _getStrictElement(e,m){return typeof e.getStrictElement=="function"?e.getStrictElement(m):null}OriginalElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(e,m){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[m]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,m,h,v,b){const C=[!1];let R=this.ComputeDiffRecursive(e,m,h,v,C);return b&&(R=this.PrettifyChanges(R)),{quitEarly:C[0],changes:R}}ComputeDiffRecursive(e,m,h,v,b){for(b[0]=!1;e<=m&&h<=v&&this.ElementsAreEqual(e,h);)e++,h++;for(;m>=e&&v>=h&&this.ElementsAreEqual(m,v);)m--,v--;if(e>m||h>v){let c;return h<=v?(L.Assert(e===m+1,"originalStart should only be one more than originalEnd"),c=[new E.DiffChange(e,0,h,v-h+1)]):e<=m?(L.Assert(h===v+1,"modifiedStart should only be one more than modifiedEnd"),c=[new E.DiffChange(e,m-e+1,h,0)]):(L.Assert(e===m+1,"originalStart should only be one more than originalEnd"),L.Assert(h===v+1,"modifiedStart should only be one more than modifiedEnd"),c=[]),c}const C=[0],R=[0],_=this.ComputeRecursionPoint(e,m,h,v,C,R,b),w=C[0],p=R[0];if(_!==null)return _;if(!b[0]){const c=this.ComputeDiffRecursive(e,w,h,p,b);let s=[];return b[0]?s=[new E.DiffChange(w+1,m-(w+1)+1,p+1,v-(p+1)+1)]:s=this.ComputeDiffRecursive(w+1,m,p+1,v,b),this.ConcatenateChanges(c,s)}return[new E.DiffChange(e,m-e+1,h,v-h+1)]}WALKTRACE(e,m,h,v,b,C,R,_,w,p,c,s,o,a,f,l,g,N){let A=null,M=null,k=new d,q=m,F=h,O=o[0]-l[0]-v,V=-1073741824,G=this.m_forwardHistory.length-1;do{const I=O+e;I===q||I<F&&w[I-1]<w[I+1]?(c=w[I+1],a=c-O-v,c<V&&k.MarkNextChange(),V=c,k.AddModifiedElement(c+1,a),O=I+1-e):(c=w[I-1]+1,a=c-O-v,c<V&&k.MarkNextChange(),V=c-1,k.AddOriginalElement(c,a+1),O=I-1-e),G>=0&&(w=this.m_forwardHistory[G],e=w[0],q=1,F=w.length-1)}while(--G>=-1);if(A=k.getReverseChanges(),N[0]){let I=o[0]+1,T=l[0]+1;if(A!==null&&A.length>0){const B=A[A.length-1];I=Math.max(I,B.getOriginalEnd()),T=Math.max(T,B.getModifiedEnd())}M=[new E.DiffChange(I,s-I+1,T,f-T+1)]}else{k=new d,q=C,F=R,O=o[0]-l[0]-_,V=1073741824,G=g?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const I=O+b;I===q||I<F&&p[I-1]>=p[I+1]?(c=p[I+1]-1,a=c-O-_,c>V&&k.MarkNextChange(),V=c+1,k.AddOriginalElement(c+1,a+1),O=I+1-b):(c=p[I-1],a=c-O-_,c>V&&k.MarkNextChange(),V=c,k.AddModifiedElement(c+1,a+1),O=I-1-b),G>=0&&(p=this.m_reverseHistory[G],b=p[0],q=1,F=p.length-1)}while(--G>=-1);M=k.getChanges()}return this.ConcatenateChanges(A,M)}ComputeRecursionPoint(e,m,h,v,b,C,R){let _=0,w=0,p=0,c=0,s=0,o=0;e--,h--,b[0]=0,C[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=m-e+(v-h),f=a+1,l=new Int32Array(f),g=new Int32Array(f),N=v-h,A=m-e,M=e-h,k=m-v,F=(A-N)%2===0;l[N]=e,g[A]=m,R[0]=!1;for(let O=1;O<=a/2+1;O++){let V=0,G=0;p=this.ClipDiagonalBound(N-O,O,N,f),c=this.ClipDiagonalBound(N+O,O,N,f);for(let T=p;T<=c;T+=2){T===p||T<c&&l[T-1]<l[T+1]?_=l[T+1]:_=l[T-1]+1,w=_-(T-N)-M;const B=_;for(;_<m&&w<v&&this.ElementsAreEqual(_+1,w+1);)_++,w++;if(l[T]=_,_+w>V+G&&(V=_,G=w),!F&&Math.abs(T-A)<=O-1&&_>=g[T])return b[0]=_,C[0]=w,B<=g[T]&&1447>0&&O<=1447+1?this.WALKTRACE(N,p,c,M,A,s,o,k,l,g,_,m,b,w,v,C,F,R):null}const I=(V-e+(G-h)-O)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(V,I))return R[0]=!0,b[0]=V,C[0]=G,I>0&&1447>0&&O<=1447+1?this.WALKTRACE(N,p,c,M,A,s,o,k,l,g,_,m,b,w,v,C,F,R):(e++,h++,[new E.DiffChange(e,m-e+1,h,v-h+1)]);s=this.ClipDiagonalBound(A-O,O,A,f),o=this.ClipDiagonalBound(A+O,O,A,f);for(let T=s;T<=o;T+=2){T===s||T<o&&g[T-1]>=g[T+1]?_=g[T+1]-1:_=g[T-1],w=_-(T-A)-k;const B=_;for(;_>e&&w>h&&this.ElementsAreEqual(_,w);)_--,w--;if(g[T]=_,F&&Math.abs(T-N)<=O&&_<=l[T])return b[0]=_,C[0]=w,B>=l[T]&&1447>0&&O<=1447+1?this.WALKTRACE(N,p,c,M,A,s,o,k,l,g,_,m,b,w,v,C,F,R):null}if(O<=1447){let T=new Int32Array(c-p+2);T[0]=N-p+1,S.Copy2(l,p,T,1,c-p+1),this.m_forwardHistory.push(T),T=new Int32Array(o-s+2),T[0]=A-s+1,S.Copy2(g,s,T,1,o-s+1),this.m_reverseHistory.push(T)}}return this.WALKTRACE(N,p,c,M,A,s,o,k,l,g,_,m,b,w,v,C,F,R)}PrettifyChanges(e){for(let m=0;m<e.length;m++){const h=e[m],v=m<e.length-1?e[m+1].originalStart:this._originalElementsOrHash.length,b=m<e.length-1?e[m+1].modifiedStart:this._modifiedElementsOrHash.length,C=h.originalLength>0,R=h.modifiedLength>0;for(;h.originalStart+h.originalLength<v&&h.modifiedStart+h.modifiedLength<b&&(!C||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!R||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const w=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!w)break;h.originalStart++,h.modifiedStart++}const _=[null];if(m<e.length-1&&this.ChangesOverlap(e[m],e[m+1],_)){e[m]=_[0],e.splice(m+1,1),m--;continue}}for(let m=e.length-1;m>=0;m--){const h=e[m];let v=0,b=0;if(m>0){const c=e[m-1];v=c.originalStart+c.originalLength,b=c.modifiedStart+c.modifiedLength}const C=h.originalLength>0,R=h.modifiedLength>0;let _=0,w=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let c=1;;c++){const s=h.originalStart-c,o=h.modifiedStart-c;if(s<v||o<b||C&&!this.OriginalElementsAreEqual(s,s+h.originalLength)||R&&!this.ModifiedElementsAreEqual(o,o+h.modifiedLength))break;const f=(s===v&&o===b?5:0)+this._boundaryScore(s,h.originalLength,o,h.modifiedLength);f>w&&(w=f,_=c)}h.originalStart-=_,h.modifiedStart-=_;const p=[null];if(m>0&&this.ChangesOverlap(e[m-1],e[m],p)){e[m-1]=p[0],e.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,h=e.length;m<h;m++){const v=e[m-1],b=e[m],C=b.originalStart-v.originalStart-v.originalLength,R=v.originalStart,_=b.originalStart+b.originalLength,w=_-R,p=v.modifiedStart,c=b.modifiedStart+b.modifiedLength,s=c-p;if(C<5&&w<20&&s<20){const o=this._findBetterContiguousSequence(R,w,p,s,C);if(o){const[a,f]=o;(a!==v.originalStart+v.originalLength||f!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=a-v.originalStart,v.modifiedLength=f-v.modifiedStart,b.originalStart=a+C,b.modifiedStart=f+C,b.originalLength=_-b.originalStart,b.modifiedLength=c-b.modifiedStart)}}}return e}_findBetterContiguousSequence(e,m,h,v,b){if(m<b||v<b)return null;const C=e+m-b+1,R=h+v-b+1;let _=0,w=0,p=0;for(let c=e;c<C;c++)for(let s=h;s<R;s++){const o=this._contiguousSequenceScore(c,s,b);o>0&&o>_&&(_=o,w=c,p=s)}return _>0?[w,p]:null}_contiguousSequenceScore(e,m,h){let v=0;for(let b=0;b<h;b++){if(!this.ElementsAreEqual(e+b,m+b))return 0;v+=this._originalStringElements[e+b].length}return v}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,m){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(m>0){const h=e+m;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,m){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(m>0){const h=e+m;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,m,h,v){const b=this._OriginalRegionIsBoundary(e,m)?1:0,C=this._ModifiedRegionIsBoundary(h,v)?1:0;return b+C}ConcatenateChanges(e,m){const h=[];if(e.length===0||m.length===0)return m.length>0?m:e;if(this.ChangesOverlap(e[e.length-1],m[0],h)){const v=new Array(e.length+m.length-1);return S.Copy(e,0,v,0,e.length-1),v[e.length-1]=h[0],S.Copy(m,1,v,e.length,m.length-1),v}else{const v=new Array(e.length+m.length);return S.Copy(e,0,v,0,e.length),S.Copy(m,0,v,e.length,m.length),v}}ChangesOverlap(e,m,h){if(L.Assert(e.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),L.Assert(e.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=m.originalStart||e.modifiedStart+e.modifiedLength>=m.modifiedStart){const v=e.originalStart;let b=e.originalLength;const C=e.modifiedStart;let R=e.modifiedLength;return e.originalStart+e.originalLength>=m.originalStart&&(b=m.originalStart+m.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=m.modifiedStart&&(R=m.modifiedStart+m.modifiedLength-e.modifiedStart),h[0]=new E.DiffChange(v,b,C,R),!0}else return h[0]=null,!1}ClipDiagonalBound(e,m,h,v){if(e>=0&&e<v)return e;const b=h,C=v-h-1,R=m%2===0;if(e<0){const _=b%2===0;return R===_?0:1}else{const _=C%2===0;return R===_?v-1:v-2}}}n.LcsDiff=u}),Y(X[18],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(_){return typeof _=="string"}n.isString=E;function D(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}n.isObject=D;function i(_){const w=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof w}n.isTypedArray=i;function r(_){return typeof _=="number"&&!isNaN(_)}n.isNumber=r;function L(_){return!!_&&typeof _[Symbol.iterator]=="function"}n.isIterable=L;function S(_){return _===!0||_===!1}n.isBoolean=S;function d(_){return typeof _>"u"}n.isUndefined=d;function u(_){return!y(_)}n.isDefined=u;function y(_){return d(_)||_===null}n.isUndefinedOrNull=y;function e(_,w){if(!_)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}n.assertType=e;function m(_){if(y(_))throw new Error("Assertion Failed: argument is undefined or null");return _}n.assertIsDefined=m;function h(_){return typeof _=="function"}n.isFunction=h;function v(_,w){const p=Math.min(_.length,w.length);for(let c=0;c<p;c++)b(_[c],w[c])}n.validateConstraints=v;function b(_,w){if(E(w)){if(typeof _!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(h(w)){try{if(_ instanceof w)return}catch{}if(!y(_)&&_.constructor===w||w.length===1&&w.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function C(_){return _===null?void 0:_}n.withNullAsUndefined=C;function R(_){return typeof _>"u"?null:_}n.withUndefinedAsNull=R}),Y(X[32],J([0,1,18]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(L,S){if((0,E.isString)(S)){const d=D[S];if(d===void 0)throw new Error(`${L} references an unknown codicon: ${S}`);S=d}return D[L]=S,{id:L}}function r(){return D}n.getCodiconFontCharacters=r,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[12],J([0,1,18]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([b,C])=>{v[b]=C&&typeof C=="object"?D(C):C}),v}n.deepClone=D;function i(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const b=v.shift();Object.freeze(b);for(const C in b)if(r.call(b,C)){const R=b[C];typeof R=="object"&&!Object.isFrozen(R)&&!(0,E.isTypedArray)(R)&&v.push(R)}}return h}n.deepFreeze=i;const r=Object.prototype.hasOwnProperty;function L(h,v){return S(h,v,new Set)}n.cloneAndChange=L;function S(h,v,b){if((0,E.isUndefinedOrNull)(h))return h;const C=v(h);if(typeof C<"u")return C;if(Array.isArray(h)){const R=[];for(const _ of h)R.push(S(_,v,b));return R}if((0,E.isObject)(h)){if(b.has(h))throw new Error("Cannot clone recursive data-structure");b.add(h);const R={};for(const _ in h)r.call(h,_)&&(R[_]=S(h[_],v,b));return b.delete(h),R}return h}function d(h,v,b=!0){return(0,E.isObject)(h)?((0,E.isObject)(v)&&Object.keys(v).forEach(C=>{C in h?b&&((0,E.isObject)(h[C])&&(0,E.isObject)(v[C])?d(h[C],v[C],b):h[C]=v[C]):h[C]=v[C]}),h):v}n.mixin=d;function u(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let b,C;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(b=0;b<h.length;b++)if(!u(h[b],v[b]))return!1}else{const R=[];for(C in h)R.push(C);R.sort();const _=[];for(C in v)_.push(C);if(_.sort(),!u(R,_))return!1;for(b=0;b<R.length;b++)if(!u(h[R[b]],v[R[b]]))return!1}return!0}n.equals=u;function y(h){let v=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)v=v.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return v}n.getAllPropertyNames=y;function e(h){const v=[];for(const b of y(h))typeof h[b]=="function"&&v.push(b);return v}n.getAllMethodNames=e;function m(h,v){const b=R=>function(){const _=Array.prototype.slice.call(arguments,0);return v(R,_)},C={};for(const R of h)C[R]=b(R);return C}n.createProxyObject=m}),Y(X[19],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),Y(X[20],J([0,1,19]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(L){const S=(0,E.toUint8)(L);this._defaultValue=S,this._asciiMap=D._createAsciiMap(S),this._map=new Map}static _createAsciiMap(L){const S=new Uint8Array(256);return S.fill(L),S}set(L,S){const d=(0,E.toUint8)(S);L>=0&&L<256?this._asciiMap[L]=d:this._map.set(L,d)}get(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class i{constructor(){this._actual=new D(0)}add(L){this._actual.set(L,1)}has(L){return this._actual.get(L)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),Y(X[21],J([0,1,4]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class D{static joinMany(r){if(r.length===0)return[];let L=r[0];for(let S=1;S<r.length;S++)L=this.join(L,r[S]);return L}static join(r,L){if(r.length===0)return L;if(L.length===0)return r;const S=[];let d=0,u=0,y=null;for(;d<r.length||u<L.length;){let e=null;if(d<r.length&&u<L.length){const m=r[d],h=L[u];m.startLineNumber<h.startLineNumber?(e=m,d++):(e=h,u++)}else d<r.length?(e=r[d],d++):(e=L[u],u++);y===null?y=e:y.endLineNumberExclusive>=e.startLineNumber?y=new D(y.startLineNumber,Math.max(y.endLineNumberExclusive,e.endLineNumberExclusive)):(S.push(y),y=e)}return y!==null&&S.push(y),S}constructor(r,L){if(r>L)throw new E.BugIndicatingError(`startLineNumber ${r} cannot be after endLineNumberExclusive ${L}`);this.startLineNumber=r,this.endLineNumberExclusive=L}contains(r){return this.startLineNumber<=r&&r<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(r){return new D(this.startLineNumber+r,this.endLineNumberExclusive+r)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(r){return new D(Math.min(this.startLineNumber,r.startLineNumber),Math.max(this.endLineNumberExclusive,r.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(r){const L=Math.max(this.startLineNumber,r.startLineNumber),S=Math.min(this.endLineNumberExclusive,r.endLineNumberExclusive);if(L<=S)return new D(L,S)}overlapOrTouch(r){return this.startLineNumber<=r.endLineNumberExclusive&&r.startLineNumber<=this.endLineNumberExclusive}equals(r){return this.startLineNumber===r.startLineNumber&&this.endLineNumberExclusive===r.endLineNumberExclusive}}n.LineRange=D}),Y(X[6],J([0,1,4]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=void 0;class D{static addRange(r,L){let S=0;for(;S<L.length&&L[S].endExclusive<r.start;)S++;let d=S;for(;d<L.length&&L[d].start<=r.endExclusive;)d++;if(S===d)L.splice(S,0,r);else{const u=Math.min(r.start,L[S].start),y=Math.max(r.endExclusive,L[d-1].endExclusive);L.splice(S,d-S,new D(u,y))}}static tryCreate(r,L){if(!(r>L))return new D(r,L)}constructor(r,L){if(this.start=r,this.endExclusive=L,r>L)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(r){return new D(this.start+r,this.endExclusive+r)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(r){return this.start===r.start&&this.endExclusive===r.endExclusive}containsRange(r){return this.start<=r.start&&r.endExclusive<=this.endExclusive}join(r){return new D(Math.min(this.start,r.start),Math.max(this.endExclusive,r.endExclusive))}intersect(r){const L=Math.max(this.start,r.start),S=Math.min(this.endExclusive,r.endExclusive);if(L<=S)return new D(L,S)}}n.OffsetRange=D}),Y(X[3],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,r){this.lineNumber=i,this.column=r}with(i=this.lineNumber,r=this.column){return i===this.lineNumber&&r===this.column?this:new E(i,r)}delta(i=0,r=0){return this.with(this.lineNumber+i,this.column+r)}equals(i){return E.equals(this,i)}static equals(i,r){return!i&&!r?!0:!!i&&!!r&&i.lineNumber===r.lineNumber&&i.column===r.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,r){return i.lineNumber<r.lineNumber?!0:r.lineNumber<i.lineNumber?!1:i.column<r.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,r){return i.lineNumber<r.lineNumber?!0:r.lineNumber<i.lineNumber?!1:i.column<=r.column}static compare(i,r){const L=i.lineNumber|0,S=r.lineNumber|0;if(L===S){const d=i.column|0,u=r.column|0;return d-u}return L-S}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),Y(X[2],J([0,1,3]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(r,L,S,d){r>S||r===S&&L>d?(this.startLineNumber=S,this.startColumn=d,this.endLineNumber=r,this.endColumn=L):(this.startLineNumber=r,this.startColumn=L,this.endLineNumber=S,this.endColumn=d)}isEmpty(){return D.isEmpty(this)}static isEmpty(r){return r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn}containsPosition(r){return D.containsPosition(this,r)}static containsPosition(r,L){return!(L.lineNumber<r.startLineNumber||L.lineNumber>r.endLineNumber||L.lineNumber===r.startLineNumber&&L.column<r.startColumn||L.lineNumber===r.endLineNumber&&L.column>r.endColumn)}static strictContainsPosition(r,L){return!(L.lineNumber<r.startLineNumber||L.lineNumber>r.endLineNumber||L.lineNumber===r.startLineNumber&&L.column<=r.startColumn||L.lineNumber===r.endLineNumber&&L.column>=r.endColumn)}containsRange(r){return D.containsRange(this,r)}static containsRange(r,L){return!(L.startLineNumber<r.startLineNumber||L.endLineNumber<r.startLineNumber||L.startLineNumber>r.endLineNumber||L.endLineNumber>r.endLineNumber||L.startLineNumber===r.startLineNumber&&L.startColumn<r.startColumn||L.endLineNumber===r.endLineNumber&&L.endColumn>r.endColumn)}strictContainsRange(r){return D.strictContainsRange(this,r)}static strictContainsRange(r,L){return!(L.startLineNumber<r.startLineNumber||L.endLineNumber<r.startLineNumber||L.startLineNumber>r.endLineNumber||L.endLineNumber>r.endLineNumber||L.startLineNumber===r.startLineNumber&&L.startColumn<=r.startColumn||L.endLineNumber===r.endLineNumber&&L.endColumn>=r.endColumn)}plusRange(r){return D.plusRange(this,r)}static plusRange(r,L){let S,d,u,y;return L.startLineNumber<r.startLineNumber?(S=L.startLineNumber,d=L.startColumn):L.startLineNumber===r.startLineNumber?(S=L.startLineNumber,d=Math.min(L.startColumn,r.startColumn)):(S=r.startLineNumber,d=r.startColumn),L.endLineNumber>r.endLineNumber?(u=L.endLineNumber,y=L.endColumn):L.endLineNumber===r.endLineNumber?(u=L.endLineNumber,y=Math.max(L.endColumn,r.endColumn)):(u=r.endLineNumber,y=r.endColumn),new D(S,d,u,y)}intersectRanges(r){return D.intersectRanges(this,r)}static intersectRanges(r,L){let S=r.startLineNumber,d=r.startColumn,u=r.endLineNumber,y=r.endColumn;const e=L.startLineNumber,m=L.startColumn,h=L.endLineNumber,v=L.endColumn;return S<e?(S=e,d=m):S===e&&(d=Math.max(d,m)),u>h?(u=h,y=v):u===h&&(y=Math.min(y,v)),S>u||S===u&&d>y?null:new D(S,d,u,y)}equalsRange(r){return D.equalsRange(this,r)}static equalsRange(r,L){return!r&&!L?!0:!!r&&!!L&&r.startLineNumber===L.startLineNumber&&r.startColumn===L.startColumn&&r.endLineNumber===L.endLineNumber&&r.endColumn===L.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(r){return new E.Position(r.endLineNumber,r.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(r){return new E.Position(r.startLineNumber,r.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(r,L){return new D(this.startLineNumber,this.startColumn,r,L)}setStartPosition(r,L){return new D(r,L,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(r){return new D(r.startLineNumber,r.startColumn,r.startLineNumber,r.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(r){return new D(r.endLineNumber,r.endColumn,r.endLineNumber,r.endColumn)}delta(r){return new D(this.startLineNumber+r,this.startColumn,this.endLineNumber+r,this.endColumn)}static fromPositions(r,L=r){return new D(r.lineNumber,r.column,L.lineNumber,L.column)}static lift(r){return r?new D(r.startLineNumber,r.startColumn,r.endLineNumber,r.endColumn):null}static isIRange(r){return r&&typeof r.startLineNumber=="number"&&typeof r.startColumn=="number"&&typeof r.endLineNumber=="number"&&typeof r.endColumn=="number"}static areIntersectingOrTouching(r,L){return!(r.endLineNumber<L.startLineNumber||r.endLineNumber===L.startLineNumber&&r.endColumn<L.startColumn||L.endLineNumber<r.startLineNumber||L.endLineNumber===r.startLineNumber&&L.endColumn<r.startColumn)}static areIntersecting(r,L){return!(r.endLineNumber<L.startLineNumber||r.endLineNumber===L.startLineNumber&&r.endColumn<=L.startColumn||L.endLineNumber<r.startLineNumber||L.endLineNumber===r.startLineNumber&&L.endColumn<=r.startColumn)}static compareRangesUsingStarts(r,L){if(r&&L){const u=r.startLineNumber|0,y=L.startLineNumber|0;if(u===y){const e=r.startColumn|0,m=L.startColumn|0;if(e===m){const h=r.endLineNumber|0,v=L.endLineNumber|0;if(h===v){const b=r.endColumn|0,C=L.endColumn|0;return b-C}return h-v}return e-m}return u-y}return(r?1:0)-(L?1:0)}static compareRangesUsingEnds(r,L){return r.endLineNumber===L.endLineNumber?r.endColumn===L.endColumn?r.startLineNumber===L.startLineNumber?r.startColumn-L.startColumn:r.startLineNumber-L.startLineNumber:r.endColumn-L.endColumn:r.endLineNumber-L.endLineNumber}static spansMultipleLines(r){return r.endLineNumber>r.startLineNumber}toJSON(){return this}}n.Range=D}),Y(X[33],J([0,1,3,2]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(L,S,d,u){super(L,S,d,u),this.selectionStartLineNumber=L,this.selectionStartColumn=S,this.positionLineNumber=d,this.positionColumn=u}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return i.selectionsEqual(this,L)}static selectionsEqual(L,S){return L.selectionStartLineNumber===S.selectionStartLineNumber&&L.selectionStartColumn===S.selectionStartColumn&&L.positionLineNumber===S.positionLineNumber&&L.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(L,S){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,L,S):new i(L,S,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,S){return this.getDirection()===0?new i(L,S,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,L,S)}static fromPositions(L,S=L){return new i(L.lineNumber,L.column,S.lineNumber,S.column)}static fromRange(L,S){return S===0?new i(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new i(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new i(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,S){if(L&&!S||!L&&S)return!1;if(!L&&!S)return!0;if(L.length!==S.length)return!1;for(let d=0,u=L.length;d<u;d++)if(!this.selectionsEqual(L[d],S[d]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,S,d,u,y){return y===0?new i(L,S,d,u):new i(d,u,L,S)}}n.Selection=i}),Y(X[34],J([0,1,20]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends E.CharacterClassifier{constructor(L){super(0);for(let S=0,d=L.length;S<d;S++)this.set(L.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(r){const L={};return S=>(L.hasOwnProperty(S)||(L[S]=r(S)),L[S])}n.getMapForWordSeparators=i(r=>new D(r))}),Y(X[22],J([0,1,15,16]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(u=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)u.indexOf(e)>=0||(y+="\\"+e);return y+="\\s]+)",new RegExp(y,"g")}n.DEFAULT_WORD_REGEXP=i();function r(u){let y=n.DEFAULT_WORD_REGEXP;if(u&&u instanceof RegExp)if(u.global)y=u;else{let e="g";u.ignoreCase&&(e+="i"),u.multiline&&(e+="m"),u.unicode&&(e+="u"),y=new RegExp(u.source,e)}return y.lastIndex=0,y}n.ensureValidWordDefinition=r;const L=new D.LinkedList;L.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(u,y,e,m,h){if(h||(h=E.Iterable.first(L)),e.length>h.maxLen){let _=u-h.maxLen/2;return _<0?_=0:m+=_,e=e.substring(_,u+h.maxLen/2),S(u,y,e,m,h)}const v=Date.now(),b=u-1-m;let C=-1,R=null;for(let _=1;!(Date.now()-v>=h.timeBudget);_++){const w=b-h.windowSize*_;y.lastIndex=Math.max(0,w);const p=d(y,e,b,C);if(!p&&R||(R=p,w<=0))break;C=w}if(R){const _={word:R[0],startColumn:m+1+R.index,endColumn:m+1+R.index+R[0].length};return y.lastIndex=0,_}return null}n.getWordAtText=S;function d(u,y,e,m){let h;for(;h=u.exec(y);){const v=h.index||0;if(v<=e&&u.lastIndex>=e)return h;if(m>0&&v>m)return null}return null}}),Y(X[7],J([0,1,4,6]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(u,y){return new i([new r(new D.OffsetRange(0,u.length),new D.OffsetRange(0,y.length))],!1)}static trivialTimedOut(u,y){return new i([new r(new D.OffsetRange(0,u.length),new D.OffsetRange(0,y.length))],!0)}constructor(u,y){this.diffs=u,this.hitTimeout=y}}n.DiffAlgorithmResult=i;class r{constructor(u,y){this.seq1Range=u,this.seq2Range=y}reverse(){return new r(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(u){return new r(this.seq1Range.join(u.seq1Range),this.seq2Range.join(u.seq2Range))}}n.SequenceDiff=r;class L{isValid(){return!0}}L.instance=new L,n.InfiniteTimeout=L;class S{constructor(u){if(this.timeout=u,this.startTime=Date.now(),this.valid=!0,u<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=S}),Y(X[35],J([0,1,6,7]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(u,y,e){let m=e;return m=L(u,y,m),m=S(u,y,m),m}n.optimizeSequenceDiffs=i;function r(u,y,e){const m=[];for(const h of e){const v=m[m.length-1];if(!v){m.push(h);continue}h.seq1Range.start-v.seq1Range.endExclusive<=2||h.seq2Range.start-v.seq2Range.endExclusive<=2?m[m.length-1]=new D.SequenceDiff(v.seq1Range.join(h.seq1Range),v.seq2Range.join(h.seq2Range)):m.push(h)}return m}n.smoothenSequenceDiffs=r;function L(u,y,e){const m=[];e.length>0&&m.push(e[0]);for(let h=1;h<e.length;h++){const v=m[m.length-1],b=e[h];if(b.seq1Range.isEmpty){let C=!0;const R=b.seq1Range.start-v.seq1Range.endExclusive;for(let _=1;_<=R;_++)if(y.getElement(b.seq2Range.start-_)!==y.getElement(b.seq2Range.endExclusive-_)){C=!1;break}if(C){m[m.length-1]=new D.SequenceDiff(v.seq1Range,new E.OffsetRange(v.seq2Range.start,b.seq2Range.endExclusive-R));continue}}m.push(b)}return m}n.joinSequenceDiffs=L;function S(u,y,e){if(!u.getBoundaryScore||!y.getBoundaryScore)return e;for(let m=0;m<e.length;m++){const h=e[m];if(h.seq1Range.isEmpty){const v=m>0?e[m-1].seq2Range.endExclusive:-1,b=m+1<e.length?e[m+1].seq2Range.start:y.length;e[m]=d(h,u,y,b,v)}else if(h.seq2Range.isEmpty){const v=m>0?e[m-1].seq1Range.endExclusive:-1,b=m+1<e.length?e[m+1].seq1Range.start:u.length;e[m]=d(h.reverse(),y,u,b,v).reverse()}}return e}n.shiftSequenceDiffs=S;function d(u,y,e,m,h){let b=1;for(;u.seq2Range.start-b>h&&e.getElement(u.seq2Range.start-b)===e.getElement(u.seq2Range.endExclusive-b)&&b<20;)b++;b--;let C=0;for(;u.seq2Range.start+C<m&&e.getElement(u.seq2Range.start+C)===e.getElement(u.seq2Range.endExclusive+C)&&C<20;)C++;if(b===0&&C===0)return u;let R=0,_=-1;for(let w=-b;w<=C;w++){const p=u.seq2Range.start+w,c=u.seq2Range.endExclusive+w,s=u.seq1Range.start+w,o=y.getBoundaryScore(s)+e.getBoundaryScore(p)+e.getBoundaryScore(c);o>_&&(_=o,R=w)}return R!==0?new D.SequenceDiff(u.seq1Range.delta(R),u.seq2Range.delta(R)):u}}),Y(X[36],J([0,1,6,7]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(u,y,e=D.InfiniteTimeout.instance){if(u.length===0||y.length===0)return D.DiffAlgorithmResult.trivial(u,y);function m(c,s){for(;c<u.length&&s<y.length&&u.getElement(c)===y.getElement(s);)c++,s++;return c}let h=0;const v=new L;v.set(0,m(0,0));const b=new S;b.set(0,v.get(0)===0?null:new r(null,0,0,v.get(0)));let C=0;e:for(;;)for(h++,C=-h;C<=h;C+=2){if(!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(u,y);const c=C===h?-1:v.get(C+1),s=C===-h?-1:v.get(C-1)+1,o=Math.min(Math.max(c,s),u.length),a=o-C,f=m(o,a);v.set(C,f);const l=o===c?b.get(C+1):b.get(C-1);if(b.set(C,f!==o?new r(l,o,a,f-o):l),v.get(C)===u.length&&v.get(C)-C===y.length)break e}let R=b.get(C);const _=[];let w=u.length,p=y.length;for(;;){const c=R?R.x+R.length:0,s=R?R.y+R.length:0;if((c!==w||s!==p)&&_.push(new D.SequenceDiff(new E.OffsetRange(c,w),new E.OffsetRange(s,p))),!R)break;w=R.x,p=R.y,R=R.prev}return _.reverse(),new D.DiffAlgorithmResult(_,!1)}}n.MyersDiffAlgorithm=i;class r{constructor(u,y,e,m){this.prev=u,this.x=y,this.y=e,this.length=m}}class L{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.negativeArr[u]):this.positiveArr[u]}set(u,y){if(u<0){if(u=-u-1,u>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[u]=y}else{if(u>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[u]=y}}}class S{constructor(){this.positiveArr=[],this.negativeArr=[]}get(u){return u<0?(u=-u-1,this.negativeArr[u]):this.positiveArr[u]}set(u,y){u<0?(u=-u-1,this.negativeArr[u]=y):this.positiveArr[u]=y}}}),Y(X[37],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,r){this.width=i,this.height=r,this.array=[],this.array=new Array(i*r)}get(i,r){return this.array[i+r*this.width]}set(i,r,L){this.array[i+r*this.width]=L}}n.Array2D=E}),Y(X[38],J([0,1,6,7,37]),function(U,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class r{compute(S,d,u=D.InfiniteTimeout.instance,y){if(S.length===0||d.length===0)return D.DiffAlgorithmResult.trivial(S,d);const e=new i.Array2D(S.length,d.length),m=new i.Array2D(S.length,d.length),h=new i.Array2D(S.length,d.length);for(let p=0;p<S.length;p++)for(let c=0;c<d.length;c++){if(!u.isValid())return D.DiffAlgorithmResult.trivialTimedOut(S,d);const s=p===0?0:e.get(p-1,c),o=c===0?0:e.get(p,c-1);let a;S.getElement(p)===d.getElement(c)?(p===0||c===0?a=0:a=e.get(p-1,c-1),p>0&&c>0&&m.get(p-1,c-1)===3&&(a+=h.get(p-1,c-1)),a+=y?y(p,c):1):a=-1;const f=Math.max(s,o,a);if(f===a){const l=p>0&&c>0?h.get(p-1,c-1):0;h.set(p,c,l+1),m.set(p,c,3)}else f===s?(h.set(p,c,0),m.set(p,c,1)):f===o&&(h.set(p,c,0),m.set(p,c,2));e.set(p,c,f)}const v=[];let b=S.length,C=d.length;function R(p,c){(p+1!==b||c+1!==C)&&v.push(new D.SequenceDiff(new E.OffsetRange(p+1,b),new E.OffsetRange(c+1,C))),b=p,C=c}let _=S.length-1,w=d.length-1;for(;_>=0&&w>=0;)m.get(_,w)===3?(R(_,w),_--,w--):m.get(_,w)===1?_--:w--;return R(-1,-1),v.reverse(),new D.DiffAlgorithmResult(v,!1)}}n.DynamicProgrammingDiffing=r}),Y(X[23],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class E{constructor(L,S){this.changes=L,this.hitTimeout=S}}n.LinesDiff=E;class D{constructor(L,S,d){this.originalRange=L,this.modifiedRange=S,this.innerChanges=d}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=D;class i{constructor(L,S){this.originalRange=L,this.modifiedRange=S}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=i}),Y(X[39],J([0,1,17,23,5,2,10,21]),function(U,n,E,D,i,r,L,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const d=3;class u{computeDiff(c,s,o){var a;const l=new C(c,s,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),g=[];let N=null;for(const A of l.changes){let M;A.originalEndLineNumber===0?M=new S.LineRange(A.originalStartLineNumber+1,A.originalStartLineNumber+1):M=new S.LineRange(A.originalStartLineNumber,A.originalEndLineNumber+1);let k;A.modifiedEndLineNumber===0?k=new S.LineRange(A.modifiedStartLineNumber+1,A.modifiedStartLineNumber+1):k=new S.LineRange(A.modifiedStartLineNumber,A.modifiedEndLineNumber+1);let q=new D.LineRangeMapping(M,k,(a=A.charChanges)===null||a===void 0?void 0:a.map(F=>new D.RangeMapping(new r.Range(F.originalStartLineNumber,F.originalStartColumn,F.originalEndLineNumber,F.originalEndColumn),new r.Range(F.modifiedStartLineNumber,F.modifiedStartColumn,F.modifiedEndLineNumber,F.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===q.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===q.originalRange.startLineNumber)&&(q=new D.LineRangeMapping(N.originalRange.join(q.originalRange),N.modifiedRange.join(q.modifiedRange),N.innerChanges&&q.innerChanges?N.innerChanges.concat(q.innerChanges):void 0),g.pop()),g.push(q),N=q}return(0,L.assertFn)(()=>(0,L.checkAdjacentItems)(g,(A,M)=>M.originalRange.startLineNumber-A.originalRange.endLineNumberExclusive===M.modifiedRange.startLineNumber-A.modifiedRange.endLineNumberExclusive&&A.originalRange.endLineNumberExclusive<M.originalRange.startLineNumber&&A.modifiedRange.endLineNumberExclusive<M.modifiedRange.startLineNumber)),new D.LinesDiff(g,l.quitEarly)}}n.SmartLinesDiffComputer=u;function y(p,c,s,o){return new E.LcsDiff(p,c,s).ComputeDiff(o)}class e{constructor(c){const s=[],o=[];for(let a=0,f=c.length;a<f;a++)s[a]=R(c[a],1),o[a]=_(c[a],1);this.lines=c,this._startColumns=s,this._endColumns=o}getElements(){const c=[];for(let s=0,o=this.lines.length;s<o;s++)c[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return c}getStrictElement(c){return this.lines[c]}getStartLineNumber(c){return c+1}getEndLineNumber(c){return c+1}createCharSequence(c,s,o){const a=[],f=[],l=[];let g=0;for(let N=s;N<=o;N++){const A=this.lines[N],M=c?this._startColumns[N]:1,k=c?this._endColumns[N]:A.length+1;for(let q=M;q<k;q++)a[g]=A.charCodeAt(q-1),f[g]=N+1,l[g]=q,g++;!c&&N<o&&(a[g]=10,f[g]=N+1,l[g]=A.length+1,g++)}return new m(a,f,l)}}class m{constructor(c,s,o){this._charCodes=c,this._lineNumbers=s,this._columns=o}toString(){return"["+this._charCodes.map((c,s)=>(c===10?"\\n":String.fromCharCode(c))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(c,s){if(c<0||c>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(c){return c>0&&c===this._lineNumbers.length?this.getEndLineNumber(c-1):(this._assertIndex(c,this._lineNumbers),this._lineNumbers[c])}getEndLineNumber(c){return c===-1?this.getStartLineNumber(c+1):(this._assertIndex(c,this._lineNumbers),this._charCodes[c]===10?this._lineNumbers[c]+1:this._lineNumbers[c])}getStartColumn(c){return c>0&&c===this._columns.length?this.getEndColumn(c-1):(this._assertIndex(c,this._columns),this._columns[c])}getEndColumn(c){return c===-1?this.getStartColumn(c+1):(this._assertIndex(c,this._columns),this._charCodes[c]===10?1:this._columns[c]+1)}}class h{constructor(c,s,o,a,f,l,g,N){this.originalStartLineNumber=c,this.originalStartColumn=s,this.originalEndLineNumber=o,this.originalEndColumn=a,this.modifiedStartLineNumber=f,this.modifiedStartColumn=l,this.modifiedEndLineNumber=g,this.modifiedEndColumn=N}static createFromDiffChange(c,s,o){const a=s.getStartLineNumber(c.originalStart),f=s.getStartColumn(c.originalStart),l=s.getEndLineNumber(c.originalStart+c.originalLength-1),g=s.getEndColumn(c.originalStart+c.originalLength-1),N=o.getStartLineNumber(c.modifiedStart),A=o.getStartColumn(c.modifiedStart),M=o.getEndLineNumber(c.modifiedStart+c.modifiedLength-1),k=o.getEndColumn(c.modifiedStart+c.modifiedLength-1);return new h(a,f,l,g,N,A,M,k)}}function v(p){if(p.length<=1)return p;const c=[p[0]];let s=c[0];for(let o=1,a=p.length;o<a;o++){const f=p[o],l=f.originalStart-(s.originalStart+s.originalLength),g=f.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(l,g)<d?(s.originalLength=f.originalStart+f.originalLength-s.originalStart,s.modifiedLength=f.modifiedStart+f.modifiedLength-s.modifiedStart):(c.push(f),s=f)}return c}class b{constructor(c,s,o,a,f){this.originalStartLineNumber=c,this.originalEndLineNumber=s,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=a,this.charChanges=f}static createFromDiffResult(c,s,o,a,f,l,g){let N,A,M,k,q;if(s.originalLength===0?(N=o.getStartLineNumber(s.originalStart)-1,A=0):(N=o.getStartLineNumber(s.originalStart),A=o.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(M=a.getStartLineNumber(s.modifiedStart)-1,k=0):(M=a.getStartLineNumber(s.modifiedStart),k=a.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),l&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&f()){const F=o.createCharSequence(c,s.originalStart,s.originalStart+s.originalLength-1),O=a.createCharSequence(c,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(F.getElements().length>0&&O.getElements().length>0){let V=y(F,O,f,!0).changes;g&&(V=v(V)),q=[];for(let G=0,I=V.length;G<I;G++)q.push(h.createFromDiffChange(V[G],F,O))}}return new b(N,A,M,k,q)}}class C{constructor(c,s,o){this.shouldComputeCharChanges=o.shouldComputeCharChanges,this.shouldPostProcessCharChanges=o.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=o.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=o.shouldMakePrettyDiff,this.originalLines=c,this.modifiedLines=s,this.original=new e(c),this.modified=new e(s),this.continueLineDiff=w(o.maxComputationTime),this.continueCharDiff=w(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const c=y(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=c.changes,o=c.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let N=0,A=s.length;N<A;N++)g.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[N],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:o,changes:g}}const a=[];let f=0,l=0;for(let g=-1,N=s.length;g<N;g++){const A=g+1<N?s[g+1]:null,M=A?A.originalStart:this.originalLines.length,k=A?A.modifiedStart:this.modifiedLines.length;for(;f<M&&l<k;){const q=this.originalLines[f],F=this.modifiedLines[l];if(q!==F){{let O=R(q,1),V=R(F,1);for(;O>1&&V>1;){const G=q.charCodeAt(O-2),I=F.charCodeAt(V-2);if(G!==I)break;O--,V--}(O>1||V>1)&&this._pushTrimWhitespaceCharChange(a,f+1,1,O,l+1,1,V)}{let O=_(q,1),V=_(F,1);const G=q.length+1,I=F.length+1;for(;O<G&&V<I;){const T=q.charCodeAt(O-1),B=q.charCodeAt(V-1);if(T!==B)break;O++,V++}(O<G||V<I)&&this._pushTrimWhitespaceCharChange(a,f+1,O,G,l+1,V,I)}}f++,l++}A&&(a.push(b.createFromDiffResult(this.shouldIgnoreTrimWhitespace,A,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),f+=A.originalLength,l+=A.modifiedLength)}return{quitEarly:o,changes:a}}_pushTrimWhitespaceCharChange(c,s,o,a,f,l,g){if(this._mergeTrimWhitespaceCharChange(c,s,o,a,f,l,g))return;let N;this.shouldComputeCharChanges&&(N=[new h(s,o,s,a,f,l,f,g)]),c.push(new b(s,s,f,f,N))}_mergeTrimWhitespaceCharChange(c,s,o,a,f,l,g){const N=c.length;if(N===0)return!1;const A=c[N-1];return A.originalEndLineNumber===0||A.modifiedEndLineNumber===0?!1:A.originalEndLineNumber===s&&A.modifiedEndLineNumber===f?(this.shouldComputeCharChanges&&A.charChanges&&A.charChanges.push(new h(s,o,s,a,f,l,f,g)),!0):A.originalEndLineNumber+1===s&&A.modifiedEndLineNumber+1===f?(A.originalEndLineNumber=s,A.modifiedEndLineNumber=f,this.shouldComputeCharChanges&&A.charChanges&&A.charChanges.push(new h(s,o,s,a,f,l,f,g)),!0):!1}}n.DiffComputer=C;function R(p,c){const s=i.firstNonWhitespaceIndex(p);return s===-1?c:s+1}function _(p,c){const s=i.lastNonWhitespaceIndex(p);return s===-1?c:s+2}function w(p){if(p===0)return()=>!0;const c=Date.now();return()=>Date.now()-c<p}}),Y(X[40],J([0,1,10,21,6,3,2,7,38,35,36,23]),function(U,n,E,D,i,r,L,S,d,u,y,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class m{constructor(){this.dynamicProgrammingDiffing=new d.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new y.MyersDiffAlgorithm}computeDiff(g,N,A){const M=A.maxComputationTimeMs===0?S.InfiniteTimeout.instance:new S.DateTimeout(A.maxComputationTimeMs),k=!A.ignoreTrimWhitespace,q=new Map;function F(re){let se=q.get(re);return se===void 0&&(se=q.size,q.set(re,se)),se}const O=g.map(re=>F(re.trim())),V=N.map(re=>F(re.trim())),G=new _(O,g),I=new _(V,N),T=(()=>G.length+I.length<1500?this.dynamicProgrammingDiffing.compute(G,I,M,(re,se)=>g[re]===N[se]?N[se].length===0?.1:1+Math.log(1+N[se].length):.99):this.myersDiffingAlgorithm.compute(G,I))();let B=T.diffs,t=T.hitTimeout;B=(0,u.optimizeSequenceDiffs)(G,I,B);const H=[],oe=re=>{if(k)for(let se=0;se<re;se++){const ge=ne+se,Le=ce+se;if(g[ge]!==N[Le]){const Z=this.refineDiff(g,N,new S.SequenceDiff(new i.OffsetRange(ge,ge+1),new i.OffsetRange(Le,Le+1)),M,k);for(const z of Z.mappings)H.push(z);Z.hitTimeout&&(t=!0)}}};let ne=0,ce=0;for(const re of B){(0,E.assertFn)(()=>re.seq1Range.start-ne===re.seq2Range.start-ce);const se=re.seq1Range.start-ne;oe(se),ne=re.seq1Range.endExclusive,ce=re.seq2Range.endExclusive;const ge=this.refineDiff(g,N,re,M,k);ge.hitTimeout&&(t=!0);for(const Le of ge.mappings)H.push(Le)}oe(g.length-ne);const _e=b(H,g,N);return new e.LinesDiff(_e,t)}refineDiff(g,N,A,M,k){const q=new p(g,A.seq1Range,k),F=new p(N,A.seq2Range,k),O=q.length+F.length<500?this.dynamicProgrammingDiffing.compute(q,F,M):this.myersDiffingAlgorithm.compute(q,F,M);let V=O.diffs;return V=(0,u.optimizeSequenceDiffs)(q,F,V),V=h(q,F,V),V=(0,u.smoothenSequenceDiffs)(q,F,V),{mappings:V.map(I=>new e.RangeMapping(q.translateRange(I.seq1Range),F.translateRange(I.seq2Range))),hitTimeout:O.hitTimeout}}}n.StandardLinesDiffComputer=m;function h(l,g,N){const A=[];let M;function k(){if(!M)return;const F=M.s1Range.length-M.deleted,O=M.s2Range.length-M.added;Math.max(M.deleted,M.added)+(M.count-1)>F&&A.push(new S.SequenceDiff(M.s1Range,M.s2Range)),M=void 0}for(const F of N){let O=function(B,t){var H,oe,ne,ce;if(!M||!M.s1Range.containsRange(B)||!M.s2Range.containsRange(t))if(M&&!(M.s1Range.endExclusive<B.start&&M.s2Range.endExclusive<t.start)){const se=i.OffsetRange.tryCreate(M.s1Range.endExclusive,B.start),ge=i.OffsetRange.tryCreate(M.s2Range.endExclusive,t.start);M.deleted+=(H=se?.length)!==null&&H!==void 0?H:0,M.added+=(oe=ge?.length)!==null&&oe!==void 0?oe:0,M.s1Range=M.s1Range.join(B),M.s2Range=M.s2Range.join(t)}else k(),M={added:0,deleted:0,count:0,s1Range:B,s2Range:t};const _e=B.intersect(F.seq1Range),re=t.intersect(F.seq2Range);M.count++,M.deleted+=(ne=_e?.length)!==null&&ne!==void 0?ne:0,M.added+=(ce=re?.length)!==null&&ce!==void 0?ce:0};const V=l.findWordContaining(F.seq1Range.start-1),G=g.findWordContaining(F.seq2Range.start-1),I=l.findWordContaining(F.seq1Range.endExclusive),T=g.findWordContaining(F.seq2Range.endExclusive);V&&I&&G&&T&&V.equals(I)&&G.equals(T)?O(V,G):(V&&G&&O(V,G),I&&T&&O(I,T))}return k(),v(N,A)}function v(l,g){const N=[];for(;l.length>0||g.length>0;){const A=l[0],M=g[0];let k;A&&(!M||A.seq1Range.start<M.seq1Range.start)?k=l.shift():k=g.shift(),N.length>0&&N[N.length-1].seq1Range.endExclusive>=k.seq1Range.start?N[N.length-1]=N[N.length-1].join(k):N.push(k)}return N}function b(l,g,N){const A=[];for(const M of R(l.map(k=>C(k,g,N)),(k,q)=>k.originalRange.overlapOrTouch(q.originalRange)||k.modifiedRange.overlapOrTouch(q.modifiedRange))){const k=M[0],q=M[M.length-1];A.push(new e.LineRangeMapping(k.originalRange.join(q.originalRange),k.modifiedRange.join(q.modifiedRange),M.map(F=>F.innerChanges[0])))}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(A,(M,k)=>k.originalRange.startLineNumber-M.originalRange.endLineNumberExclusive===k.modifiedRange.startLineNumber-M.modifiedRange.endLineNumberExclusive&&M.originalRange.endLineNumberExclusive<k.originalRange.startLineNumber&&M.modifiedRange.endLineNumberExclusive<k.modifiedRange.startLineNumber)),A}n.lineRangeMappingFromRangeMappings=b;function C(l,g,N){let A=0,M=0;l.modifiedRange.startColumn-1>=N[l.modifiedRange.startLineNumber-1].length&&l.originalRange.startColumn-1>=g[l.originalRange.startLineNumber-1].length&&(A=1),l.modifiedRange.endColumn===1&&l.originalRange.endColumn===1&&l.originalRange.startLineNumber+A<=l.originalRange.endLineNumber&&l.modifiedRange.startLineNumber+A<=l.modifiedRange.endLineNumber&&(M=-1);const k=new D.LineRange(l.originalRange.startLineNumber+A,l.originalRange.endLineNumber+1+M),q=new D.LineRange(l.modifiedRange.startLineNumber+A,l.modifiedRange.endLineNumber+1+M);return new e.LineRangeMapping(k,q,[l])}n.getLineRangeMapping=C;function*R(l,g){let N,A;for(const M of l)A!==void 0&&g(A,M)?N.push(M):(N&&(yield N),N=[M]),A=M;N&&(yield N)}class _{constructor(g,N){this.trimmedHash=g,this.lines=N}getElement(g){return this.trimmedHash[g]}get length(){return this.trimmedHash.length}getBoundaryScore(g){const N=g===0?0:w(this.lines[g-1]),A=g===this.lines.length?0:w(this.lines[g]);return 1e3-(N+A)}}n.LineSequence=_;function w(l){let g=0;for(;g<l.length&&(l.charCodeAt(g)===32||l.charCodeAt(g)===9);)g++;return g}class p{constructor(g,N,A){this.lines=g,this.considerWhitespaceChanges=A,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let M=!1;N.start>0&&N.endExclusive>=g.length&&(N=new i.OffsetRange(N.start-1,N.endExclusive),M=!0),this.lineRange=N;for(let k=this.lineRange.start;k<this.lineRange.endExclusive;k++){let q=g[k],F=0;if(M)F=q.length,q="",M=!1;else if(!A){const O=q.trimStart();F=q.length-O.length,q=O.trimEnd()}this.offsetByLine.push(F);for(let O=0;O<q.length;O++)this.elements.push(q.charCodeAt(O));k<g.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[k-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.elements].map(g=>String.fromCharCode(g)).join("")}getElement(g){return this.elements[g]}get length(){return this.elements.length}getBoundaryScore(g){const N=a(g>0?this.elements[g-1]:-1),A=a(g<this.elements.length?this.elements[g]:-1);if(N===6&&A===7)return 0;let M=0;return N!==A&&(M+=10,A===1&&(M+=1)),M+=o(N),M+=o(A),M}translateOffset(g){if(this.lineRange.isEmpty)return new r.Position(this.lineRange.start+1,1);let N=0,A=this.firstCharOffsetByLineMinusOne.length;for(;N<A;){const k=Math.floor((N+A)/2);this.firstCharOffsetByLineMinusOne[k]>g?A=k:N=k+1}const M=N===0?0:this.firstCharOffsetByLineMinusOne[N-1];return new r.Position(this.lineRange.start+N+1,g-M+1+this.offsetByLine[N])}translateRange(g){return L.Range.fromPositions(this.translateOffset(g.start),this.translateOffset(g.endExclusive))}findWordContaining(g){if(g<0||g>=this.elements.length||!c(this.elements[g]))return;let N=g;for(;N>0&&c(this.elements[N-1]);)N--;let A=g;for(;A<this.elements.length&&c(this.elements[A]);)A++;return new i.OffsetRange(N,A)}}function c(l){return l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57}const s={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function o(l){return s[l]}function a(l){return l===10?7:l===13?6:f(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function f(l){return l===32||l===9}}),Y(X[41],J([0,1,39,40]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new E.SmartLinesDiffComputer,experimental:new D.StandardLinesDiffComputer}}),Y(X[42],J([0,1,20]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(m,h,v){const b=new Uint8Array(m*h);for(let C=0,R=m*h;C<R;C++)b[C]=v;this._data=b,this.rows=m,this.cols=h}get(m,h){return this._data[m*this.cols+h]}set(m,h,v){this._data[m*this.cols+h]=v}}class i{constructor(m){let h=0,v=0;for(let C=0,R=m.length;C<R;C++){const[_,w,p]=m[C];w>h&&(h=w),_>v&&(v=_),p>v&&(v=p)}h++,v++;const b=new D(v,h,0);for(let C=0,R=m.length;C<R;C++){const[_,w,p]=m[C];b.set(_,w,p)}this._states=b,this._maxCharCode=h}nextState(m,h){return h<0||h>=this._maxCharCode?0:this._states.get(m,h)}}n.StateMachine=i;let r=null;function L(){return r===null&&(r=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),r}let S=null;function d(){if(S===null){S=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)S.set(e.charCodeAt(h),1);const m=".,;:";for(let h=0;h<m.length;h++)S.set(m.charCodeAt(h),2)}return S}class u{static _createLink(m,h,v,b,C){let R=C-1;do{const _=h.charCodeAt(R);if(m.get(_)!==2)break;R--}while(R>b);if(b>0){const _=h.charCodeAt(b-1),w=h.charCodeAt(R);(_===40&&w===41||_===91&&w===93||_===123&&w===125)&&R--}return{range:{startLineNumber:v,startColumn:b+1,endLineNumber:v,endColumn:R+2},url:h.substring(b,R+1)}}static computeLinks(m,h=L()){const v=d(),b=[];for(let C=1,R=m.getLineCount();C<=R;C++){const _=m.getLineContent(C),w=_.length;let p=0,c=0,s=0,o=1,a=!1,f=!1,l=!1,g=!1;for(;p<w;){let N=!1;const A=_.charCodeAt(p);if(o===13){let M;switch(A){case 40:a=!0,M=0;break;case 41:M=a?0:1;break;case 91:l=!0,f=!0,M=0;break;case 93:l=!1,M=f?0:1;break;case 123:g=!0,M=0;break;case 125:M=g?0:1;break;case 39:case 34:case 96:s===A?M=1:s===39||s===34||s===96?M=0:M=1;break;case 42:M=s===42?1:0;break;case 124:M=s===124?1:0;break;case 32:M=l?0:1;break;default:M=v.get(A)}M===1&&(b.push(u._createLink(v,_,C,c,p)),N=!0)}else if(o===12){let M;A===91?(f=!0,M=0):M=v.get(A),M===1?N=!0:o=13}else o=h.nextState(o,A),o===0&&(N=!0);N&&(o=1,a=!1,f=!1,g=!1,c=p+1,s=A),p++}o===13&&b.push(u._createLink(v,_,C,c,w))}return b}}n.LinkComputer=u;function y(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:u.computeLinks(e)}n.computeLinks=y}),Y(X[43],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,r,L,S,d){if(i&&r){const u=this.doNavigateValueSet(r,d);if(u)return{range:i,value:u}}if(L&&S){const u=this.doNavigateValueSet(S,d);if(u)return{range:L,value:u}}return null}doNavigateValueSet(i,r){const L=this.numberReplace(i,r);return L!==null?L:this.textReplace(i,r)}numberReplace(i,r){const L=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let S=Number(i);const d=parseFloat(i);return!isNaN(S)&&!isNaN(d)&&S===d?S===0&&!r?null:(S=Math.floor(S*L),S+=r?L:-L,String(S/L)):null}textReplace(i,r){return this.valueSetsReplace(this._defaultValueSet,i,r)}valueSetsReplace(i,r,L){let S=null;for(let d=0,u=i.length;S===null&&d<u;d++)S=this.valueSetReplace(i[d],r,L);return S}valueSetReplace(i,r,L){let S=i.indexOf(r);return S>=0?(S+=L?1:-1,S<0?S=i.length-1:S%=i.length,i[S]):null}}E.INSTANCE=new E,n.BasicInplaceReplace=E}),Y(X[44],J([0,1,12]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var D;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(D=n.OverviewRulerLane||(n.OverviewRulerLane={}));var i;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(i=n.MinimapPosition||(n.MinimapPosition={}));var r;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(r=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),v.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,v.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!v.insertSpaces,this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=!!v.trimAutoWhitespace,this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this._indentSizeIsTabSize===v._indentSizeIsTabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}n.TextModelResolvedOptions=L;class S{constructor(v,b){this._findMatchBrand=void 0,this.range=v,this.matches=b}}n.FindMatch=S;function d(h){return h&&typeof h.read=="function"}n.isITextSnapshot=d;class u{constructor(v,b,C,R,_,w){this.identifier=v,this.range=b,this.text=C,this.forceMoveMarkers=R,this.isAutoWhitespaceEdit=_,this._isTracked=w}}n.ValidAnnotatedEditOperation=u;class y{constructor(v,b,C){this.regex=v,this.wordSeparators=b,this.simpleSearch=C}}n.SearchData=y;class e{constructor(v,b,C){this.reverseEdits=v,this.changes=b,this.trimAutoWhitespaceLineNumbers=C}}n.ApplyEditsResult=e;function m(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=m}),Y(X[45],J([0,1,26,19]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(d){this.values=d,this.prefixSum=new Uint32Array(d.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(d,u){d=(0,D.toUint32)(d);const y=this.values,e=this.prefixSum,m=u.length;return m===0?!1:(this.values=new Uint32Array(y.length+m),this.values.set(y.subarray(0,d),0),this.values.set(y.subarray(d),d+m),this.values.set(u,d),d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(d,u){return d=(0,D.toUint32)(d),u=(0,D.toUint32)(u),this.values[d]===u?!1:(this.values[d]=u,d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),!0)}removeValues(d,u){d=(0,D.toUint32)(d),u=(0,D.toUint32)(u);const y=this.values,e=this.prefixSum;if(d>=y.length)return!1;const m=y.length-d;return u>=m&&(u=m),u===0?!1:(this.values=new Uint32Array(y.length-u),this.values.set(y.subarray(0,d),0),this.values.set(y.subarray(d+u),d),this.prefixSum=new Uint32Array(this.values.length),d-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=d-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(d){return d<0?0:(d=(0,D.toUint32)(d),this._getPrefixSum(d))}_getPrefixSum(d){if(d<=this.prefixSumValidIndex[0])return this.prefixSum[d];let u=this.prefixSumValidIndex[0]+1;u===0&&(this.prefixSum[0]=this.values[0],u++),d>=this.values.length&&(d=this.values.length-1);for(let y=u;y<=d;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],d),this.prefixSum[d]}getIndexOf(d){d=Math.floor(d),this.getTotalSum();let u=0,y=this.values.length-1,e=0,m=0,h=0;for(;u<=y;)if(e=u+(y-u)/2|0,m=this.prefixSum[e],h=m-this.values[e],d<h)y=e-1;else if(d>=m)u=e+1;else break;return new L(e,d-h)}}n.PrefixSumComputer=i;class r{constructor(d){this._values=d,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(d){return this._ensureValid(),d===0?0:this._prefixSum[d-1]}getIndexOf(d){this._ensureValid();const u=this._indexBySum[d],y=u>0?this._prefixSum[u-1]:0;return new L(u,d-y)}removeValues(d,u){this._values.splice(d,u),this._invalidate(d)}insertValues(d,u){this._values=(0,E.arrayInsert)(this._values,d,u),this._invalidate(d)}_invalidate(d){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,d-1)}_ensureValid(){if(!this._isValid){for(let d=this._validEndIndex+1,u=this._values.length;d<u;d++){const y=this._values[d],e=d>0?this._prefixSum[d-1]:0;this._prefixSum[d]=e+y;for(let m=0;m<y;m++)this._indexBySum[e+m]=d}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(d,u){this._values[d]!==u&&(this._values[d]=u,this._invalidate(d))}}n.ConstantTimePrefixSumComputer=r;class L{constructor(d,u){this.index=d,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=d,this.remainder=u}}n.PrefixSumIndexOfResult=L}),Y(X[46],J([0,1,5,3,45]),function(U,n,E,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class r{constructor(S,d,u,y){this._uri=S,this._lines=d,this._eol=u,this._versionId=y,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const d=S.changes;for(const u of d)this._acceptDeleteRange(u.range),this._acceptInsertText(new D.Position(u.range.startLineNumber,u.range.startColumn),u.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,d=this._lines.length,u=new Uint32Array(d);for(let y=0;y<d;y++)u[y]=this._lines[y].length+S;this._lineStarts=new i.PrefixSumComputer(u)}}_setLineText(S,d){this._lines[S]=d,this._lineStarts&&this._lineStarts.setValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,d){if(d.length===0)return;const u=(0,E.splitLines)(d);if(u.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+u[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}u[u.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+u[0]);const y=new Uint32Array(u.length-1);for(let e=1;e<u.length;e++)this._lines.splice(S.lineNumber+e-1,0,u[e]),y[e-1]=u[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,y)}}n.MirrorTextModel=r}),Y(X[47],J([0,1,5,34,3,2,44]),function(U,n,E,D,i,r,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const S=999;class d{constructor(_,w,p,c){this.searchString=_,this.isRegex=w,this.matchCase=p,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=u(this.searchString):_=this.searchString.indexOf(`
`)>=0;let w=null;try{w=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!w)return null;let p=!this.isRegex&&!_;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new L.SearchData(w,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}n.SearchParams=d;function u(R){if(!R||R.length===0)return!1;for(let _=0,w=R.length;_<w;_++){const p=R.charCodeAt(_);if(p===10)return!0;if(p===92){if(_++,_>=w)break;const c=R.charCodeAt(_);if(c===110||c===114||c===87)return!0}}return!1}n.isMultilineRegexSource=u;function y(R,_,w){if(!w)return new L.FindMatch(R,null);const p=[];for(let c=0,s=_.length;c<s;c++)p[c]=_[c];return new L.FindMatch(R,p)}n.createFindMatch=y;class e{constructor(_){const w=[];let p=0;for(let c=0,s=_.length;c<s;c++)_.charCodeAt(c)===10&&(w[p++]=c);this._lineFeedsOffsets=w}findLineFeedCountBeforeOffset(_){const w=this._lineFeedsOffsets;let p=0,c=w.length-1;if(c===-1||_<=w[0])return 0;for(;p<c;){const s=p+((c-p)/2>>0);w[s]>=_?c=s-1:w[s+1]>=_?(p=s,c=s):p=s+1}return p+1}}class m{static findMatches(_,w,p,c,s){const o=w.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(_,p,new C(o.wordSeparators,o.regex),c,s):this._doFindMatchesLineByLine(_,p,o,c,s):[]}static _getMultilineMatchRange(_,w,p,c,s,o){let a,f=0;c?(f=c.findLineFeedCountBeforeOffset(s),a=w+s+f):a=w+s;let l;if(c){const M=c.findLineFeedCountBeforeOffset(s+o.length)-f;l=a+o.length+M}else l=a+o.length;const g=_.getPositionAt(a),N=_.getPositionAt(l);return new r.Range(g.lineNumber,g.column,N.lineNumber,N.column)}static _doFindMatchesMultiline(_,w,p,c,s){const o=_.getOffsetAt(w.getStartPosition()),a=_.getValueInRange(w,1),f=_.getEOL()===`\r
`?new e(a):null,l=[];let g=0,N;for(p.reset(0);N=p.next(a);)if(l[g++]=y(this._getMultilineMatchRange(_,o,a,f,N.index,N[0]),N,c),g>=s)return l;return l}static _doFindMatchesLineByLine(_,w,p,c,s){const o=[];let a=0;if(w.startLineNumber===w.endLineNumber){const l=_.getLineContent(w.startLineNumber).substring(w.startColumn-1,w.endColumn-1);return a=this._findMatchesInLine(p,l,w.startLineNumber,w.startColumn-1,a,o,c,s),o}const f=_.getLineContent(w.startLineNumber).substring(w.startColumn-1);a=this._findMatchesInLine(p,f,w.startLineNumber,w.startColumn-1,a,o,c,s);for(let l=w.startLineNumber+1;l<w.endLineNumber&&a<s;l++)a=this._findMatchesInLine(p,_.getLineContent(l),l,0,a,o,c,s);if(a<s){const l=_.getLineContent(w.endLineNumber).substring(0,w.endColumn-1);a=this._findMatchesInLine(p,l,w.endLineNumber,0,a,o,c,s)}return o}static _findMatchesInLine(_,w,p,c,s,o,a,f){const l=_.wordSeparators;if(!a&&_.simpleSearch){const A=_.simpleSearch,M=A.length,k=w.length;let q=-M;for(;(q=w.indexOf(A,q+M))!==-1;)if((!l||b(l,w,k,q,M))&&(o[s++]=new L.FindMatch(new r.Range(p,q+1+c,p,q+1+M+c),null),s>=f))return s;return s}const g=new C(_.wordSeparators,_.regex);let N;g.reset(0);do if(N=g.next(w),N&&(o[s++]=y(new r.Range(p,N.index+1+c,p,N.index+1+N[0].length+c),N,a),s>=f))return s;while(N);return s}static findNextMatch(_,w,p,c){const s=w.parseSearchRequest();if(!s)return null;const o=new C(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(_,p,o,c):this._doFindNextMatchLineByLine(_,p,o,c)}static _doFindNextMatchMultiline(_,w,p,c){const s=new i.Position(w.lineNumber,1),o=_.getOffsetAt(s),a=_.getLineCount(),f=_.getValueInRange(new r.Range(s.lineNumber,s.column,a,_.getLineMaxColumn(a)),1),l=_.getEOL()===`\r
`?new e(f):null;p.reset(w.column-1);const g=p.next(f);return g?y(this._getMultilineMatchRange(_,o,f,l,g.index,g[0]),g,c):w.lineNumber!==1||w.column!==1?this._doFindNextMatchMultiline(_,new i.Position(1,1),p,c):null}static _doFindNextMatchLineByLine(_,w,p,c){const s=_.getLineCount(),o=w.lineNumber,a=_.getLineContent(o),f=this._findFirstMatchInLine(p,a,o,w.column,c);if(f)return f;for(let l=1;l<=s;l++){const g=(o+l-1)%s,N=_.getLineContent(g+1),A=this._findFirstMatchInLine(p,N,g+1,1,c);if(A)return A}return null}static _findFirstMatchInLine(_,w,p,c,s){_.reset(c-1);const o=_.next(w);return o?y(new r.Range(p,o.index+1,p,o.index+1+o[0].length),o,s):null}static findPreviousMatch(_,w,p,c){const s=w.parseSearchRequest();if(!s)return null;const o=new C(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(_,p,o,c):this._doFindPreviousMatchLineByLine(_,p,o,c)}static _doFindPreviousMatchMultiline(_,w,p,c){const s=this._doFindMatchesMultiline(_,new r.Range(1,1,w.lineNumber,w.column),p,c,10*S);if(s.length>0)return s[s.length-1];const o=_.getLineCount();return w.lineNumber!==o||w.column!==_.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(_,new i.Position(o,_.getLineMaxColumn(o)),p,c):null}static _doFindPreviousMatchLineByLine(_,w,p,c){const s=_.getLineCount(),o=w.lineNumber,a=_.getLineContent(o).substring(0,w.column-1),f=this._findLastMatchInLine(p,a,o,c);if(f)return f;for(let l=1;l<=s;l++){const g=(s+o-l-1)%s,N=_.getLineContent(g+1),A=this._findLastMatchInLine(p,N,g+1,c);if(A)return A}return null}static _findLastMatchInLine(_,w,p,c){let s=null,o;for(_.reset(0);o=_.next(w);)s=y(new r.Range(p,o.index+1,p,o.index+1+o[0].length),o,c);return s}}n.TextModelSearch=m;function h(R,_,w,p,c){if(p===0)return!0;const s=_.charCodeAt(p-1);if(R.get(s)!==0||s===13||s===10)return!0;if(c>0){const o=_.charCodeAt(p);if(R.get(o)!==0)return!0}return!1}function v(R,_,w,p,c){if(p+c===w)return!0;const s=_.charCodeAt(p+c);if(R.get(s)!==0||s===13||s===10)return!0;if(c>0){const o=_.charCodeAt(p+c-1);if(R.get(o)!==0)return!0}return!1}function b(R,_,w,p,c){return h(R,_,w,p,c)&&v(R,_,w,p,c)}n.isValidMatch=b;class C{constructor(_,w){this._wordSeparators=_,this._searchRegex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const w=_.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===w||(p=this._searchRegex.exec(_),!p))return null;const c=p.index,s=p[0].length;if(c===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){E.getNextCodePoint(_,w,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=s,!this._wordSeparators||b(this._wordSeparators,_,w,c,s))return p}while(p);return null}}n.Searcher=C}),Y(X[48],J([0,1,2,47,5,10,22]),function(U,n,E,D,i,r,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class S{static computeUnicodeHighlights(m,h,v){const b=v?v.startLineNumber:1,C=v?v.endLineNumber:m.getLineCount(),R=new u(h),_=R.getCandidateCodePoints();let w;_==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${d(Array.from(_))}`,"g");const p=new D.Searcher(null,w),c=[];let s=!1,o,a=0,f=0,l=0;e:for(let g=b,N=C;g<=N;g++){const A=m.getLineContent(g),M=A.length;p.reset(0);do if(o=p.next(A),o){let k=o.index,q=o.index+o[0].length;if(k>0){const G=A.charCodeAt(k-1);i.isHighSurrogate(G)&&k--}if(q+1<M){const G=A.charCodeAt(q-1);i.isHighSurrogate(G)&&q++}const F=A.substring(k,q);let O=(0,L.getWordAtText)(k+1,L.DEFAULT_WORD_REGEXP,A,0);O&&O.endColumn<=k+1&&(O=null);const V=R.shouldHighlightNonBasicASCII(F,O?O.word:null);if(V!==0){V===3?a++:V===2?f++:V===1?l++:(0,r.assertNever)(V);const G=1e3;if(c.length>=G){s=!0;break e}c.push(new E.Range(g,k+1,g,q+1))}}while(o)}return{ranges:c,hasMore:s,ambiguousCharacterCount:a,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:l}}static computeUnicodeHighlightReason(m,h){const v=new u(h);switch(v.shouldHighlightNonBasicASCII(m,null)){case 0:return null;case 2:return{kind:1};case 3:{const C=m.codePointAt(0),R=v.ambiguousCharacters.getPrimaryConfusable(C),_=i.AmbiguousCharacters.getLocales().filter(w=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,w])).isAmbiguous(C));return{kind:0,confusableWith:String.fromCodePoint(R),notAmbiguousInLocales:_}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=S;function d(e,m){return`[${i.escapeRegExpCharacters(e.map(v=>String.fromCodePoint(v)).join(""))}]`}class u{constructor(m){this.options=m,this.allowedCodePoints=new Set(m.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(m.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const m=new Set;if(this.options.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)y(String.fromCodePoint(h))||m.add(h);if(this.options.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())m.add(h);for(const h of this.allowedCodePoints)m.delete(h);return m}shouldHighlightNonBasicASCII(m,h){const v=m.codePointAt(0);if(this.allowedCodePoints.has(v))return 0;if(this.options.nonBasicASCII)return 1;let b=!1,C=!1;if(h)for(const R of h){const _=R.codePointAt(0),w=i.isBasicASCII(R);b=b||w,!w&&!this.ambiguousCharacters.isAmbiguous(_)&&!i.InvisibleCharacters.isInvisibleCharacter(_)&&(C=!0)}return!b&&C?0:this.options.invisibleCharacters&&!y(m)&&i.InvisibleCharacters.isInvisibleCharacter(v)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(v)?3:0}}function y(e){return e===" "||e===`
`||e==="	"}}),Y(X[49],J([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E=n.AccessibilitySupport||(n.AccessibilitySupport={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var r;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(r=n.CompletionItemKind||(n.CompletionItemKind={}));var L;(function(t){t[t.Deprecated=1]="Deprecated"})(L=n.CompletionItemTag||(n.CompletionItemTag={}));var S;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var d;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(d=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var u;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(u=n.CursorChangeReason||(n.CursorChangeReason={}));var y;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(y=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var m;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(m=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=7]="autoClosingDelete",t[t.autoClosingOvertype=8]="autoClosingOvertype",t[t.autoClosingQuotes=9]="autoClosingQuotes",t[t.autoIndent=10]="autoIndent",t[t.automaticLayout=11]="automaticLayout",t[t.autoSurround=12]="autoSurround",t[t.bracketPairColorization=13]="bracketPairColorization",t[t.guides=14]="guides",t[t.codeLens=15]="codeLens",t[t.codeLensFontFamily=16]="codeLensFontFamily",t[t.codeLensFontSize=17]="codeLensFontSize",t[t.colorDecorators=18]="colorDecorators",t[t.colorDecoratorsLimit=19]="colorDecoratorsLimit",t[t.columnSelection=20]="columnSelection",t[t.comments=21]="comments",t[t.contextmenu=22]="contextmenu",t[t.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",t[t.cursorBlinking=24]="cursorBlinking",t[t.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",t[t.cursorStyle=26]="cursorStyle",t[t.cursorSurroundingLines=27]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",t[t.cursorWidth=29]="cursorWidth",t[t.disableLayerHinting=30]="disableLayerHinting",t[t.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",t[t.domReadOnly=32]="domReadOnly",t[t.dragAndDrop=33]="dragAndDrop",t[t.dropIntoEditor=34]="dropIntoEditor",t[t.emptySelectionClipboard=35]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",t[t.extraEditorClassName=37]="extraEditorClassName",t[t.fastScrollSensitivity=38]="fastScrollSensitivity",t[t.find=39]="find",t[t.fixedOverflowWidgets=40]="fixedOverflowWidgets",t[t.folding=41]="folding",t[t.foldingStrategy=42]="foldingStrategy",t[t.foldingHighlight=43]="foldingHighlight",t[t.foldingImportsByDefault=44]="foldingImportsByDefault",t[t.foldingMaximumRegions=45]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=47]="fontFamily",t[t.fontInfo=48]="fontInfo",t[t.fontLigatures=49]="fontLigatures",t[t.fontSize=50]="fontSize",t[t.fontWeight=51]="fontWeight",t[t.fontVariations=52]="fontVariations",t[t.formatOnPaste=53]="formatOnPaste",t[t.formatOnType=54]="formatOnType",t[t.glyphMargin=55]="glyphMargin",t[t.gotoLocation=56]="gotoLocation",t[t.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",t[t.hover=58]="hover",t[t.inDiffEditor=59]="inDiffEditor",t[t.inlineSuggest=60]="inlineSuggest",t[t.letterSpacing=61]="letterSpacing",t[t.lightbulb=62]="lightbulb",t[t.lineDecorationsWidth=63]="lineDecorationsWidth",t[t.lineHeight=64]="lineHeight",t[t.lineNumbers=65]="lineNumbers",t[t.lineNumbersMinChars=66]="lineNumbersMinChars",t[t.linkedEditing=67]="linkedEditing",t[t.links=68]="links",t[t.matchBrackets=69]="matchBrackets",t[t.minimap=70]="minimap",t[t.mouseStyle=71]="mouseStyle",t[t.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=73]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",t[t.multiCursorModifier=75]="multiCursorModifier",t[t.multiCursorPaste=76]="multiCursorPaste",t[t.multiCursorLimit=77]="multiCursorLimit",t[t.occurrencesHighlight=78]="occurrencesHighlight",t[t.overviewRulerBorder=79]="overviewRulerBorder",t[t.overviewRulerLanes=80]="overviewRulerLanes",t[t.padding=81]="padding",t[t.parameterHints=82]="parameterHints",t[t.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",t[t.quickSuggestions=85]="quickSuggestions",t[t.quickSuggestionsDelay=86]="quickSuggestionsDelay",t[t.readOnly=87]="readOnly",t[t.renameOnType=88]="renameOnType",t[t.renderControlCharacters=89]="renderControlCharacters",t[t.renderFinalNewline=90]="renderFinalNewline",t[t.renderLineHighlight=91]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=93]="renderValidationDecorations",t[t.renderWhitespace=94]="renderWhitespace",t[t.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",t[t.roundedSelection=96]="roundedSelection",t[t.rulers=97]="rulers",t[t.scrollbar=98]="scrollbar",t[t.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=100]="scrollBeyondLastLine",t[t.scrollPredominantAxis=101]="scrollPredominantAxis",t[t.selectionClipboard=102]="selectionClipboard",t[t.selectionHighlight=103]="selectionHighlight",t[t.selectOnLineNumbers=104]="selectOnLineNumbers",t[t.showFoldingControls=105]="showFoldingControls",t[t.showUnused=106]="showUnused",t[t.snippetSuggestions=107]="snippetSuggestions",t[t.smartSelect=108]="smartSelect",t[t.smoothScrolling=109]="smoothScrolling",t[t.stickyScroll=110]="stickyScroll",t[t.stickyTabStops=111]="stickyTabStops",t[t.stopRenderingLineAfter=112]="stopRenderingLineAfter",t[t.suggest=113]="suggest",t[t.suggestFontSize=114]="suggestFontSize",t[t.suggestLineHeight=115]="suggestLineHeight",t[t.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",t[t.suggestSelection=117]="suggestSelection",t[t.tabCompletion=118]="tabCompletion",t[t.tabIndex=119]="tabIndex",t[t.unicodeHighlighting=120]="unicodeHighlighting",t[t.unusualLineTerminators=121]="unusualLineTerminators",t[t.useShadowDOM=122]="useShadowDOM",t[t.useTabStops=123]="useTabStops",t[t.wordBreak=124]="wordBreak",t[t.wordSeparators=125]="wordSeparators",t[t.wordWrap=126]="wordWrap",t[t.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=129]="wordWrapColumn",t[t.wordWrapOverride1=130]="wordWrapOverride1",t[t.wordWrapOverride2=131]="wordWrapOverride2",t[t.wrappingIndent=132]="wrappingIndent",t[t.wrappingStrategy=133]="wrappingStrategy",t[t.showDeprecated=134]="showDeprecated",t[t.inlayHints=135]="inlayHints",t[t.editorClassName=136]="editorClassName",t[t.pixelRatio=137]="pixelRatio",t[t.tabFocusMode=138]="tabFocusMode",t[t.layoutInfo=139]="layoutInfo",t[t.wrappingInfo=140]="wrappingInfo"})(h=n.EditorOption||(n.EditorOption={}));var v;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v=n.EndOfLinePreference||(n.EndOfLinePreference={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b=n.EndOfLineSequence||(n.EndOfLineSequence={}));var C;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(C=n.IndentAction||(n.IndentAction={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var _;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={}));var w;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(w=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(p=n.KeyCode||(n.KeyCode={}));var c;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(c=n.MarkerSeverity||(n.MarkerSeverity={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s=n.MarkerTag||(n.MarkerTag={}));var o;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(o=n.MinimapPosition||(n.MinimapPosition={}));var a;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(a=n.MouseTargetType||(n.MouseTargetType={}));var f;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(f=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var l;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(l=n.OverviewRulerLane||(n.OverviewRulerLane={}));var g;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(g=n.PositionAffinity||(n.PositionAffinity={}));var N;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(N=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var A;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(A=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var k;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(k=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var q;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(q=n.SelectionDirection||(n.SelectionDirection={}));var F;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(F=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var O;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(O=n.SymbolKind||(n.SymbolKind={}));var V;(function(t){t[t.Deprecated=1]="Deprecated"})(V=n.SymbolTag||(n.SymbolTag={}));var G;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(G=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var I;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(I=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var T;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var B;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(B=n.WrappingIndent||(n.WrappingIndent={}))}),Y(X[50],J([25,57]),function(U,n){return U.create("vs/base/common/platform",n)}),Y(X[8],J([0,1,50]),function(U,n,E){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,r=!1,L=!1,S=!1,d=!1,u=!1,y=!1,e=!1,m=!1,h=!1,v,b=n.LANGUAGE_DEFAULT,C=n.LANGUAGE_DEFAULT,R,_;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?w=n.globals.vscode.process:typeof process<"u"&&(w=process);const p=typeof((D=w?.versions)===null||D===void 0?void 0:D.electron)=="string",c=p&&w?.type==="renderer";if(typeof navigator=="object"&&!c)_=navigator.userAgent,i=_.indexOf("Windows")>=0,r=_.indexOf("Macintosh")>=0,e=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=_.indexOf("Linux")>=0,h=_?.indexOf("Mobi")>=0,u=!0,v=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,b=v,C=navigator.language;else if(typeof w=="object"){i=w.platform==="win32",r=w.platform==="darwin",L=w.platform==="linux",S=L&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,y=p,m=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=n.LANGUAGE_DEFAULT,b=n.LANGUAGE_DEFAULT;const l=w.env.VSCODE_NLS_CONFIG;if(l)try{const g=JSON.parse(l),N=g.availableLanguages["*"];v=g.locale,C=g.osLocale,b=N||n.LANGUAGE_DEFAULT,R=g._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");let s=0;r?s=1:i?s=3:L&&(s=2),n.isWindows=i,n.isMacintosh=r,n.isLinux=L,n.isNative=d,n.isWeb=u,n.isWebWorker=u&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=_,n.language=b,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const l=[];n.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let A=0,M=l.length;A<M;A++){const k=l[A];if(k.id===N.data.vscodeScheduleAsyncWork){l.splice(A,1),k.callback();return}}});let g=0;return N=>{const A=++g;l.push({id:A,callback:N}),n.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return l=>setTimeout(l)})(),n.OS=r||e?2:i?1:3;let o=!0,a=!1;function f(){if(!a){a=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,o=new Uint16Array(l.buffer)[0]===(2<<8)+1}return o}n.isLittleEndian=f,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[51],J([0,1,8]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),Y(X[52],J([0,1,51]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,r=90,L=122,S=46,d=47,u=92,y=58,e=63;class m extends Error{constructor(o,a,f){let l;typeof a=="string"&&a.indexOf("not ")===0?(l="must not be",a=a.replace(/^not /,"")):l="must be";const g=o.indexOf(".")!==-1?"property":"argument";let N=`The "${o}" ${g} ${l} of type ${a}`;N+=`. Received type ${typeof f}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,o){if(s===null||typeof s!="object")throw new m(o,"Object",s)}function v(s,o){if(typeof s!="string")throw new m(o,"string",s)}const b=E.platform==="win32";function C(s){return s===d||s===u}function R(s){return s===d}function _(s){return s>=D&&s<=r||s>=i&&s<=L}function w(s,o,a,f){let l="",g=0,N=-1,A=0,M=0;for(let k=0;k<=s.length;++k){if(k<s.length)M=s.charCodeAt(k);else{if(f(M))break;M=d}if(f(M)){if(!(N===k-1||A===1))if(A===2){if(l.length<2||g!==2||l.charCodeAt(l.length-1)!==S||l.charCodeAt(l.length-2)!==S){if(l.length>2){const q=l.lastIndexOf(a);q===-1?(l="",g=0):(l=l.slice(0,q),g=l.length-1-l.lastIndexOf(a)),N=k,A=0;continue}else if(l.length!==0){l="",g=0,N=k,A=0;continue}}o&&(l+=l.length>0?`${a}..`:"..",g=2)}else l.length>0?l+=`${a}${s.slice(N+1,k)}`:l=s.slice(N+1,k),g=k-N-1;N=k,A=0}else M===S&&A!==-1?++A:A=-1}return l}function p(s,o){h(o,"pathObject");const a=o.dir||o.root,f=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${f}`:`${a}${s}${f}`:f}n.win32={resolve(...s){let o="",a="",f=!1;for(let l=s.length-1;l>=-1;l--){let g;if(l>=0){if(g=s[l],v(g,"path"),g.length===0)continue}else o.length===0?g=E.cwd():(g=E.env[`=${o}`]||E.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==o.toLowerCase()&&g.charCodeAt(2)===u)&&(g=`${o}\\`));const N=g.length;let A=0,M="",k=!1;const q=g.charCodeAt(0);if(N===1)C(q)&&(A=1,k=!0);else if(C(q))if(k=!0,C(g.charCodeAt(1))){let F=2,O=F;for(;F<N&&!C(g.charCodeAt(F));)F++;if(F<N&&F!==O){const V=g.slice(O,F);for(O=F;F<N&&C(g.charCodeAt(F));)F++;if(F<N&&F!==O){for(O=F;F<N&&!C(g.charCodeAt(F));)F++;(F===N||F!==O)&&(M=`\\\\${V}\\${g.slice(O,F)}`,A=F)}}}else A=1;else _(q)&&g.charCodeAt(1)===y&&(M=g.slice(0,2),A=2,N>2&&C(g.charCodeAt(2))&&(k=!0,A=3));if(M.length>0)if(o.length>0){if(M.toLowerCase()!==o.toLowerCase())continue}else o=M;if(f){if(o.length>0)break}else if(a=`${g.slice(A)}\\${a}`,f=k,k&&o.length>0)break}return a=w(a,!f,"\\",C),f?`${o}\\${a}`:`${o}${a}`||"."},normalize(s){v(s,"path");const o=s.length;if(o===0)return".";let a=0,f,l=!1;const g=s.charCodeAt(0);if(o===1)return R(g)?"\\":s;if(C(g))if(l=!0,C(s.charCodeAt(1))){let A=2,M=A;for(;A<o&&!C(s.charCodeAt(A));)A++;if(A<o&&A!==M){const k=s.slice(M,A);for(M=A;A<o&&C(s.charCodeAt(A));)A++;if(A<o&&A!==M){for(M=A;A<o&&!C(s.charCodeAt(A));)A++;if(A===o)return`\\\\${k}\\${s.slice(M)}\\`;A!==M&&(f=`\\\\${k}\\${s.slice(M,A)}`,a=A)}}}else a=1;else _(g)&&s.charCodeAt(1)===y&&(f=s.slice(0,2),a=2,o>2&&C(s.charCodeAt(2))&&(l=!0,a=3));let N=a<o?w(s.slice(a),!l,"\\",C):"";return N.length===0&&!l&&(N="."),N.length>0&&C(s.charCodeAt(o-1))&&(N+="\\"),f===void 0?l?`\\${N}`:N:l?`${f}\\${N}`:`${f}${N}`},isAbsolute(s){v(s,"path");const o=s.length;if(o===0)return!1;const a=s.charCodeAt(0);return C(a)||o>2&&_(a)&&s.charCodeAt(1)===y&&C(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,a;for(let g=0;g<s.length;++g){const N=s[g];v(N,"path"),N.length>0&&(o===void 0?o=a=N:o+=`\\${N}`)}if(o===void 0)return".";let f=!0,l=0;if(typeof a=="string"&&C(a.charCodeAt(0))){++l;const g=a.length;g>1&&C(a.charCodeAt(1))&&(++l,g>2&&(C(a.charCodeAt(2))?++l:f=!1))}if(f){for(;l<o.length&&C(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return n.win32.normalize(o)},relative(s,o){if(v(s,"from"),v(o,"to"),s===o)return"";const a=n.win32.resolve(s),f=n.win32.resolve(o);if(a===f||(s=a.toLowerCase(),o=f.toLowerCase(),s===o))return"";let l=0;for(;l<s.length&&s.charCodeAt(l)===u;)l++;let g=s.length;for(;g-1>l&&s.charCodeAt(g-1)===u;)g--;const N=g-l;let A=0;for(;A<o.length&&o.charCodeAt(A)===u;)A++;let M=o.length;for(;M-1>A&&o.charCodeAt(M-1)===u;)M--;const k=M-A,q=N<k?N:k;let F=-1,O=0;for(;O<q;O++){const G=s.charCodeAt(l+O);if(G!==o.charCodeAt(A+O))break;G===u&&(F=O)}if(O!==q){if(F===-1)return f}else{if(k>q){if(o.charCodeAt(A+O)===u)return f.slice(A+O+1);if(O===2)return f.slice(A+O)}N>q&&(s.charCodeAt(l+O)===u?F=O:O===2&&(F=3)),F===-1&&(F=0)}let V="";for(O=l+F+1;O<=g;++O)(O===g||s.charCodeAt(O)===u)&&(V+=V.length===0?"..":"\\..");return A+=F,V.length>0?`${V}${f.slice(A,M)}`:(f.charCodeAt(A)===u&&++A,f.slice(A,M))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=n.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const a=o.charCodeAt(2);if(a!==e&&a!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(_(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return s},dirname(s){v(s,"path");const o=s.length;if(o===0)return".";let a=-1,f=0;const l=s.charCodeAt(0);if(o===1)return C(l)?s:".";if(C(l)){if(a=f=1,C(s.charCodeAt(1))){let A=2,M=A;for(;A<o&&!C(s.charCodeAt(A));)A++;if(A<o&&A!==M){for(M=A;A<o&&C(s.charCodeAt(A));)A++;if(A<o&&A!==M){for(M=A;A<o&&!C(s.charCodeAt(A));)A++;if(A===o)return s;A!==M&&(a=f=A+1)}}}}else _(l)&&s.charCodeAt(1)===y&&(a=o>2&&C(s.charCodeAt(2))?3:2,f=a);let g=-1,N=!0;for(let A=o-1;A>=f;--A)if(C(s.charCodeAt(A))){if(!N){g=A;break}}else N=!1;if(g===-1){if(a===-1)return".";g=a}return s.slice(0,g)},basename(s,o){o!==void 0&&v(o,"ext"),v(s,"path");let a=0,f=-1,l=!0,g;if(s.length>=2&&_(s.charCodeAt(0))&&s.charCodeAt(1)===y&&(a=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let N=o.length-1,A=-1;for(g=s.length-1;g>=a;--g){const M=s.charCodeAt(g);if(C(M)){if(!l){a=g+1;break}}else A===-1&&(l=!1,A=g+1),N>=0&&(M===o.charCodeAt(N)?--N===-1&&(f=g):(N=-1,f=A))}return a===f?f=A:f===-1&&(f=s.length),s.slice(a,f)}for(g=s.length-1;g>=a;--g)if(C(s.charCodeAt(g))){if(!l){a=g+1;break}}else f===-1&&(l=!1,f=g+1);return f===-1?"":s.slice(a,f)},extname(s){v(s,"path");let o=0,a=-1,f=0,l=-1,g=!0,N=0;s.length>=2&&s.charCodeAt(1)===y&&_(s.charCodeAt(0))&&(o=f=2);for(let A=s.length-1;A>=o;--A){const M=s.charCodeAt(A);if(C(M)){if(!g){f=A+1;break}continue}l===-1&&(g=!1,l=A+1),M===S?a===-1?a=A:N!==1&&(N=1):a!==-1&&(N=-1)}return a===-1||l===-1||N===0||N===1&&a===l-1&&a===f+1?"":s.slice(a,l)},format:p.bind(null,"\\"),parse(s){v(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const a=s.length;let f=0,l=s.charCodeAt(0);if(a===1)return C(l)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(C(l)){if(f=1,C(s.charCodeAt(1))){let F=2,O=F;for(;F<a&&!C(s.charCodeAt(F));)F++;if(F<a&&F!==O){for(O=F;F<a&&C(s.charCodeAt(F));)F++;if(F<a&&F!==O){for(O=F;F<a&&!C(s.charCodeAt(F));)F++;F===a?f=F:F!==O&&(f=F+1)}}}}else if(_(l)&&s.charCodeAt(1)===y){if(a<=2)return o.root=o.dir=s,o;if(f=2,C(s.charCodeAt(2))){if(a===3)return o.root=o.dir=s,o;f=3}}f>0&&(o.root=s.slice(0,f));let g=-1,N=f,A=-1,M=!0,k=s.length-1,q=0;for(;k>=f;--k){if(l=s.charCodeAt(k),C(l)){if(!M){N=k+1;break}continue}A===-1&&(M=!1,A=k+1),l===S?g===-1?g=k:q!==1&&(q=1):g!==-1&&(q=-1)}return A!==-1&&(g===-1||q===0||q===1&&g===A-1&&g===N+1?o.base=o.name=s.slice(N,A):(o.name=s.slice(N,g),o.base=s.slice(N,A),o.ext=s.slice(g,A))),N>0&&N!==f?o.dir=s.slice(0,N-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(b){const s=/\\/g;return()=>{const o=E.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...s){let o="",a=!1;for(let f=s.length-1;f>=-1&&!a;f--){const l=f>=0?s[f]:c();v(l,"path"),l.length!==0&&(o=`${l}/${o}`,a=l.charCodeAt(0)===d)}return o=w(o,!a,"/",R),a?`/${o}`:o.length>0?o:"."},normalize(s){if(v(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===d,a=s.charCodeAt(s.length-1)===d;return s=w(s,!o,"/",R),s.length===0?o?"/":a?"./":".":(a&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return v(s,"path"),s.length>0&&s.charCodeAt(0)===d},join(...s){if(s.length===0)return".";let o;for(let a=0;a<s.length;++a){const f=s[a];v(f,"path"),f.length>0&&(o===void 0?o=f:o+=`/${f}`)}return o===void 0?".":n.posix.normalize(o)},relative(s,o){if(v(s,"from"),v(o,"to"),s===o||(s=n.posix.resolve(s),o=n.posix.resolve(o),s===o))return"";const a=1,f=s.length,l=f-a,g=1,N=o.length-g,A=l<N?l:N;let M=-1,k=0;for(;k<A;k++){const F=s.charCodeAt(a+k);if(F!==o.charCodeAt(g+k))break;F===d&&(M=k)}if(k===A)if(N>A){if(o.charCodeAt(g+k)===d)return o.slice(g+k+1);if(k===0)return o.slice(g+k)}else l>A&&(s.charCodeAt(a+k)===d?M=k:k===0&&(M=0));let q="";for(k=a+M+1;k<=f;++k)(k===f||s.charCodeAt(k)===d)&&(q+=q.length===0?"..":"/..");return`${q}${o.slice(g+M)}`},toNamespacedPath(s){return s},dirname(s){if(v(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===d;let a=-1,f=!0;for(let l=s.length-1;l>=1;--l)if(s.charCodeAt(l)===d){if(!f){a=l;break}}else f=!1;return a===-1?o?"/":".":o&&a===1?"//":s.slice(0,a)},basename(s,o){o!==void 0&&v(o,"ext"),v(s,"path");let a=0,f=-1,l=!0,g;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let N=o.length-1,A=-1;for(g=s.length-1;g>=0;--g){const M=s.charCodeAt(g);if(M===d){if(!l){a=g+1;break}}else A===-1&&(l=!1,A=g+1),N>=0&&(M===o.charCodeAt(N)?--N===-1&&(f=g):(N=-1,f=A))}return a===f?f=A:f===-1&&(f=s.length),s.slice(a,f)}for(g=s.length-1;g>=0;--g)if(s.charCodeAt(g)===d){if(!l){a=g+1;break}}else f===-1&&(l=!1,f=g+1);return f===-1?"":s.slice(a,f)},extname(s){v(s,"path");let o=-1,a=0,f=-1,l=!0,g=0;for(let N=s.length-1;N>=0;--N){const A=s.charCodeAt(N);if(A===d){if(!l){a=N+1;break}continue}f===-1&&(l=!1,f=N+1),A===S?o===-1?o=N:g!==1&&(g=1):o!==-1&&(g=-1)}return o===-1||f===-1||g===0||g===1&&o===f-1&&o===a+1?"":s.slice(o,f)},format:p.bind(null,"/"),parse(s){v(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const a=s.charCodeAt(0)===d;let f;a?(o.root="/",f=1):f=0;let l=-1,g=0,N=-1,A=!0,M=s.length-1,k=0;for(;M>=f;--M){const q=s.charCodeAt(M);if(q===d){if(!A){g=M+1;break}continue}N===-1&&(A=!1,N=M+1),q===S?l===-1?l=M:k!==1&&(k=1):l!==-1&&(k=-1)}if(N!==-1){const q=g===0&&a?1:g;l===-1||k===0||k===1&&l===N-1&&l===g+1?o.base=o.name=s.slice(q,N):(o.name=s.slice(q,l),o.base=s.slice(q,N),o.ext=s.slice(l,N))}return g>0?o.dir=s.slice(0,g-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=b?n.win32.normalize:n.posix.normalize,n.resolve=b?n.win32.resolve:n.posix.resolve,n.relative=b?n.win32.relative:n.posix.relative,n.dirname=b?n.win32.dirname:n.posix.dirname,n.basename=b?n.win32.basename:n.posix.basename,n.extname=b?n.win32.extname:n.posix.extname,n.sep=b?n.win32.sep:n.posix.sep}),Y(X[24],J([0,1,8]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const D=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(L=!0){return new i(L)}constructor(L){this._highResolution=D&&L,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}n.StopWatch=i}),Y(X[9],J([0,1,4,14,11,16,24]),function(U,n,E,D,i,r,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.EventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const S=!1,d=!1;var u;(function(f){f.None=()=>i.Disposable.None;function l(Z){if(d){const{onDidAddListener:z}=Z,Q=h.create();let $=0;Z.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),z?.()}}}function g(Z,z){return G(Z,()=>{},0,void 0,!0,void 0,z)}f.defer=g;function N(Z){return(z,Q=null,$)=>{let ee=!1,te;return te=Z(ie=>{if(!ee)return te?te.dispose():ee=!0,z.call(Q,ie)},null,$),ee&&te.dispose(),te}}f.once=N;function A(Z,z,Q){return V(($,ee=null,te)=>Z(ie=>$.call(ee,z(ie)),null,te),Q)}f.map=A;function M(Z,z,Q){return V(($,ee=null,te)=>Z(ie=>{z(ie),$.call(ee,ie)},null,te),Q)}f.forEach=M;function k(Z,z,Q){return V(($,ee=null,te)=>Z(ie=>z(ie)&&$.call(ee,ie),null,te),Q)}f.filter=k;function q(Z){return Z}f.signal=q;function F(...Z){return(z,Q=null,$)=>(0,i.combinedDisposable)(...Z.map(ee=>ee(te=>z.call(Q,te),null,$)))}f.any=F;function O(Z,z,Q,$){let ee=Q;return A(Z,te=>(ee=z(ee,te),ee),$)}f.reduce=O;function V(Z,z){let Q;const $={onWillAddFirstListener(){Q=Z(ee.fire,ee)},onDidRemoveLastListener(){Q?.dispose()}};z||l($);const ee=new b($);return z?.add(ee),ee.event}function G(Z,z,Q=100,$=!1,ee=!1,te,ie){let fe,Se,we,he=0,me;const P={leakWarningThreshold:te,onWillAddFirstListener(){fe=Z(W=>{he++,Se=z(Se,W),$&&!we&&(x.fire(Se),Se=void 0),me=()=>{const j=Se;Se=void 0,we=void 0,(!$||he>1)&&x.fire(j),he=0},typeof Q=="number"?(clearTimeout(we),we=setTimeout(me,Q)):we===void 0&&(we=0,queueMicrotask(me))})},onWillRemoveListener(){ee&&he>0&&me?.()},onDidRemoveLastListener(){me=void 0,fe.dispose()}};ie||l(P);const x=new b(P);return ie?.add(x),x.event}f.debounce=G;function I(Z,z=0,Q){return f.debounce(Z,($,ee)=>$?($.push(ee),$):[ee],z,void 0,!0,void 0,Q)}f.accumulate=I;function T(Z,z=($,ee)=>$===ee,Q){let $=!0,ee;return k(Z,te=>{const ie=$||!z(te,ee);return $=!1,ee=te,ie},Q)}f.latch=T;function B(Z,z,Q){return[f.filter(Z,z,Q),f.filter(Z,$=>!z($),Q)]}f.split=B;function t(Z,z=!1,Q=[]){let $=Q.slice(),ee=Z(fe=>{$?$.push(fe):ie.fire(fe)});const te=()=>{$?.forEach(fe=>ie.fire(fe)),$=null},ie=new b({onWillAddFirstListener(){ee||(ee=Z(fe=>ie.fire(fe)))},onDidAddFirstListener(){$&&(z?setTimeout(te):te())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return ie.event}f.buffer=t;class H{constructor(z){this.event=z,this.disposables=new i.DisposableStore}map(z){return new H(A(this.event,z,this.disposables))}forEach(z){return new H(M(this.event,z,this.disposables))}filter(z){return new H(k(this.event,z,this.disposables))}reduce(z,Q){return new H(O(this.event,z,Q,this.disposables))}latch(){return new H(T(this.event,void 0,this.disposables))}debounce(z,Q=100,$=!1,ee=!1,te){return new H(G(this.event,z,Q,$,ee,te,this.disposables))}on(z,Q,$){return this.event(z,Q,$)}once(z,Q,$){return N(this.event)(z,Q,$)}dispose(){this.disposables.dispose()}}function oe(Z){return new H(Z)}f.chain=oe;function ne(Z,z,Q=$=>$){const $=(...fe)=>ie.fire(Q(...fe)),ee=()=>Z.on(z,$),te=()=>Z.removeListener(z,$),ie=new b({onWillAddFirstListener:ee,onDidRemoveLastListener:te});return ie.event}f.fromNodeEventEmitter=ne;function ce(Z,z,Q=$=>$){const $=(...fe)=>ie.fire(Q(...fe)),ee=()=>Z.addEventListener(z,$),te=()=>Z.removeEventListener(z,$),ie=new b({onWillAddFirstListener:ee,onDidRemoveLastListener:te});return ie.event}f.fromDOMEventEmitter=ce;function _e(Z){return new Promise(z=>N(Z)(z))}f.toPromise=_e;function re(Z,z){return z(void 0),Z(Q=>z(Q))}f.runAndSubscribe=re;function se(Z,z){let Q=null;function $(te){Q?.dispose(),Q=new i.DisposableStore,z(te,Q)}$(void 0);const ee=Z(te=>$(te));return(0,i.toDisposable)(()=>{ee.dispose(),Q?.dispose()})}f.runAndSubscribeWithStore=se;class ge{constructor(z,Q){this.obs=z,this._counter=0,this._hasChanged=!1;const $={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};Q||l($),this.emitter=new b($),Q&&Q.add(this.emitter)}beginUpdate(z){this._counter++}handleChange(z,Q){this._hasChanged=!0}endUpdate(z){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Le(Z,z){return new ge(Z,z).emitter.event}f.fromObservable=Le})(u=n.Event||(n.Event={}));class y{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${y._idPool++}`,y.all.add(this)}start(l){this._stopWatch=new L.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}y.all=new Set,y._idPool=0,n.EventProfiling=y;let e=-1;class m{constructor(l,g=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=g,this._warnCountdown=0}dispose(){var l;(l=this._stacks)===null||l===void 0||l.clear()}check(l,g){const N=this.threshold;if(N<=0||g<N)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=N*.5;let M,k=0;for(const[q,F]of this._stacks)(!M||k<F)&&(M=q,k=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${k}):`),console.warn(M)}return()=>{const M=this._stacks.get(l.value)||0;this._stacks.set(l.value,M-1)}}}class h{static create(){var l;return new h((l=new Error().stack)!==null&&l!==void 0?l:"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(l,g,N){this.callback=l,this.callbackThis=g,this.stack=N,this.subscription=new i.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class b{constructor(l){var g,N,A,M,k;this._disposed=!1,this._options=l,this._leakageMon=e>0||!((g=this._options)===null||g===void 0)&&g.leakWarningThreshold?new m((A=(N=this._options)===null||N===void 0?void 0:N.leakWarningThreshold)!==null&&A!==void 0?A:e):void 0,this._perfMon=!((M=this._options)===null||M===void 0)&&M._profName?new y(this._options._profName):void 0,this._deliveryQueue=(k=this._options)===null||k===void 0?void 0:k.deliveryQueue}dispose(){var l,g,N,A;if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const M=Array.from(this._listeners);queueMicrotask(()=>{var k;for(const q of M)q.subscription.isset()&&(q.subscription.unset(),(k=q.stack)===null||k===void 0||k.print())})}this._listeners.clear()}(l=this._deliveryQueue)===null||l===void 0||l.clear(this),(N=(g=this._options)===null||g===void 0?void 0:g.onDidRemoveLastListener)===null||N===void 0||N.call(g),(A=this._leakageMon)===null||A===void 0||A.dispose()}}get event(){return this._event||(this._event=(l,g,N)=>{var A,M,k;if(this._listeners||(this._listeners=new r.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const q=this._listeners.isEmpty();q&&(!((A=this._options)===null||A===void 0)&&A.onWillAddFirstListener)&&this._options.onWillAddFirstListener(this);let F,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=h.create(),F=this._leakageMon.check(O,this._listeners.size+1)),S&&(O=O??h.create());const V=new v(l,g,O),G=this._listeners.push(V);q&&(!((M=this._options)===null||M===void 0)&&M.onDidAddFirstListener)&&this._options.onDidAddFirstListener(this),!((k=this._options)===null||k===void 0)&&k.onDidAddListener&&this._options.onDidAddListener(this,l,g);const I=V.subscription.set(()=>{var T,B;F?.(),this._disposed||((B=(T=this._options)===null||T===void 0?void 0:T.onWillRemoveListener)===null||B===void 0||B.call(T,this),G(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return N instanceof i.DisposableStore?N.add(I):Array.isArray(N)&&N.push(I),I}),this._event}fire(l){var g,N,A;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R((g=this._options)===null||g===void 0?void 0:g.onListenerError));for(const M of this._listeners)this._deliveryQueue.push(this,M,l);(N=this._perfMon)===null||N===void 0||N.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(A=this._perfMon)===null||A===void 0||A.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=b;class C{constructor(l=E.onUnexpectedError){this._onListenerError=l,this._queue=new r.LinkedList}get size(){return this._queue.size}push(l,g,N){this._queue.push(new _(l,g,N))}clear(l){const g=new r.LinkedList;for(const N of this._queue)N.emitter!==l&&g.push(N);this._queue=g}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(g){this._onListenerError(g)}}}}n.EventDeliveryQueue=C;class R extends C{clear(l){this._queue.clear()}}class _{constructor(l,g,N){this.emitter=l,this.listener=g,this.event=N}}class w extends b{constructor(l){super(l),this._isPaused=0,this._eventQueue=new r.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}n.PauseableEmitter=w;class p extends w{constructor(l){var g;super(l),this._delay=(g=l.delay)!==null&&g!==void 0?g:100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}n.DebounceEmitter=p;class c extends b{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this.hasListeners()&&(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=c;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const g={event:l,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const N=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,i.toDisposable)((0,D.once)(N))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(g=>this.emitter.fire(g))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=s;class o{constructor(){this.buffers=[]}wrapEvent(l){return(g,N,A)=>l(M=>{const k=this.buffers[this.buffers.length-1];k?k.push(()=>g.call(N,M)):g.call(N,M)},void 0,A)}bufferEvents(l){const g=[];this.buffers.push(g);const N=l();return this.buffers.pop(),g.forEach(A=>A()),N}}n.EventBufferer=o;class a{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=i.Disposable.None,this.emitter=new b({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=a}),Y(X[53],J([0,1,9]),function(U,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(S,d){const u=setTimeout(S.bind(d),0);return{dispose(){clearTimeout(u)}}});var i;(function(S){function d(u){return u===S.None||u===S.Cancelled||u instanceof r?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}S.isCancellationToken=d,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i=n.CancellationToken||(n.CancellationToken={}));class r{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new r),this._token}cancel(){this._token?this._token instanceof r&&this._token.cancel():this._token=i.Cancelled}dispose(d=!1){var u;d&&this.cancel(),(u=this._parentListener)===null||u===void 0||u.dispose(),this._token?this._token instanceof r&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=L}),Y(X[13],J([0,1,52,8]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,r=/^\//,L=/^\/\//;function S(a,f){if(!a.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!i.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!r.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(a,f){return!a&&!f?"file":a}function u(a,f){switch(a){case"https":case"http":case"file":f?f[0]!==e&&(f=e+f):f=e;break}return f}const y="",e="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(f){return f instanceof h?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,l,g,N,A,M=!1){typeof f=="object"?(this.scheme=f.scheme||y,this.authority=f.authority||y,this.path=f.path||y,this.query=f.query||y,this.fragment=f.fragment||y):(this.scheme=d(f,M),this.authority=l||y,this.path=u(this.scheme,g||y),this.query=N||y,this.fragment=A||y,S(this,M))}get fsPath(){return w(this,!1)}with(f){if(!f)return this;let{scheme:l,authority:g,path:N,query:A,fragment:M}=f;return l===void 0?l=this.scheme:l===null&&(l=y),g===void 0?g=this.authority:g===null&&(g=y),N===void 0?N=this.path:N===null&&(N=y),A===void 0?A=this.query:A===null&&(A=y),M===void 0?M=this.fragment:M===null&&(M=y),l===this.scheme&&g===this.authority&&N===this.path&&A===this.query&&M===this.fragment?this:new b(l,g,N,A,M)}static parse(f,l=!1){const g=m.exec(f);return g?new b(g[2]||y,o(g[4]||y),o(g[5]||y),o(g[7]||y),o(g[9]||y),l):new b(y,y,y,y,y)}static file(f){let l=y;if(D.isWindows&&(f=f.replace(/\\/g,e)),f[0]===e&&f[1]===e){const g=f.indexOf(e,2);g===-1?(l=f.substring(2),f=e):(l=f.substring(2,g),f=f.substring(g)||e)}return new b("file",l,f,y,y)}static from(f){const l=new b(f.scheme,f.authority,f.path,f.query,f.fragment);return S(l,!0),l}static joinPath(f,...l){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return D.isWindows&&f.scheme==="file"?g=h.file(E.win32.join(w(f,!0),...l)).path:g=E.posix.join(f.path,...l),f.with({path:g})}toString(f=!1){return p(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof h)return f;{const l=new b(f);return l._formatted=f.external,l._fsPath=f._sep===v?f.fsPath:null,l}}else return f}}n.URI=h;const v=D.isWindows?1:void 0;class b extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(f=!1){return f?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=v),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(a,f,l){let g,N=-1;for(let A=0;A<a.length;A++){const M=a.charCodeAt(A);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||f&&M===47||l&&M===91||l&&M===93||l&&M===58)N!==-1&&(g+=encodeURIComponent(a.substring(N,A)),N=-1),g!==void 0&&(g+=a.charAt(A));else{g===void 0&&(g=a.substr(0,A));const k=C[M];k!==void 0?(N!==-1&&(g+=encodeURIComponent(a.substring(N,A)),N=-1),g+=k):N===-1&&(N=A)}}return N!==-1&&(g+=encodeURIComponent(a.substring(N))),g!==void 0?g:a}function _(a){let f;for(let l=0;l<a.length;l++){const g=a.charCodeAt(l);g===35||g===63?(f===void 0&&(f=a.substr(0,l)),f+=C[g]):f!==void 0&&(f+=a[l])}return f!==void 0?f:a}function w(a,f){let l;return a.authority&&a.path.length>1&&a.scheme==="file"?l=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?f?l=a.path.substr(1):l=a.path[1].toLowerCase()+a.path.substr(2):l=a.path,D.isWindows&&(l=l.replace(/\//g,"\\")),l}n.uriToFsPath=w;function p(a,f){const l=f?_:R;let g="",{scheme:N,authority:A,path:M,query:k,fragment:q}=a;if(N&&(g+=N,g+=":"),(A||N==="file")&&(g+=e,g+=e),A){let F=A.indexOf("@");if(F!==-1){const O=A.substr(0,F);A=A.substr(F+1),F=O.lastIndexOf(":"),F===-1?g+=l(O,!1,!1):(g+=l(O.substr(0,F),!1,!1),g+=":",g+=l(O.substr(F+1),!1,!0)),g+="@"}A=A.toLowerCase(),F=A.lastIndexOf(":"),F===-1?g+=l(A,!1,!0):(g+=l(A.substr(0,F),!1,!0),g+=A.substr(F))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const F=M.charCodeAt(1);F>=65&&F<=90&&(M=`/${String.fromCharCode(F+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const F=M.charCodeAt(0);F>=65&&F<=90&&(M=`${String.fromCharCode(F+32)}:${M.substr(2)}`)}g+=l(M,!0,!1)}return k&&(g+="?",g+=l(k,!1,!1)),q&&(g+="#",g+=f?q:R(q,!1,!1)),g}function c(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+c(a.substr(3)):a}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(a){return a.match(s)?a.replace(s,f=>c(f)):a}}),Y(X[58],J([0,1,4,9,11,12,8,5]),function(U,n,E,D,i,r,L,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const d="$initialize";let u=!1;function y(o){L.isWeb&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=y;class e{constructor(a,f,l,g){this.vsWorker=a,this.req=f,this.method=l,this.args=g,this.type=0}}class m{constructor(a,f,l,g){this.vsWorker=a,this.seq=f,this.res=l,this.err=g,this.type=1}}class h{constructor(a,f,l,g){this.vsWorker=a,this.req=f,this.eventName=l,this.arg=g,this.type=2}}class v{constructor(a,f,l){this.vsWorker=a,this.req=f,this.event=l,this.type=3}}class b{constructor(a,f){this.vsWorker=a,this.req=f,this.type=4}}class C{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,f){const l=String(++this._lastSentReq);return new Promise((g,N)=>{this._pendingReplies[l]={resolve:g,reject:N},this._send(new e(this._workerId,l,a,f))})}listen(a,f){let l=null;const g=new D.Emitter({onWillAddFirstListener:()=>{l=String(++this._lastSentReq),this._pendingEmitters.set(l,g),this._send(new h(this._workerId,l,a,f))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(l),this._send(new b(this._workerId,l)),l=null}});return g.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const f=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let l=a.err;a.err.$isError&&(l=new Error,l.name=a.err.name,l.message=a.err.message,l.stack=a.err.stack),f.reject(l);return}f.resolve(a.res)}_handleRequestMessage(a){const f=a.req;this._handler.handleMessage(a.method,a.args).then(g=>{this._send(new m(this._workerId,f,g,void 0))},g=>{g.detail instanceof Error&&(g.detail=(0,E.transformErrorForSerialization)(g.detail)),this._send(new m(this._workerId,f,void 0,(0,E.transformErrorForSerialization)(g)))})}_handleSubscribeEventMessage(a){const f=a.req,l=this._handler.handleEvent(a.eventName,a.arg)(g=>{this._send(new v(this._workerId,f,g))});this._pendingEvents.set(f,l)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const f=[];if(a.type===0)for(let l=0;l<a.args.length;l++)a.args[l]instanceof ArrayBuffer&&f.push(a.args[l]);else a.type===1&&a.res instanceof ArrayBuffer&&f.push(a.res);this._handler.sendMessage(a,f)}}class R extends i.Disposable{constructor(a,f,l){super();let g=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",F=>{this._protocol.handleMessage(F)},F=>{g?.(F)})),this._protocol=new C({sendMessage:(F,O)=>{this._worker.postMessage(F,O)},handleMessage:(F,O)=>{if(typeof l[F]!="function")return Promise.reject(new Error("Missing method "+F+" on main thread host."));try{return Promise.resolve(l[F].apply(l,O))}catch(V){return Promise.reject(V)}},handleEvent:(F,O)=>{if(w(F)){const V=l[F].call(l,O);if(typeof V!="function")throw new Error(`Missing dynamic event ${F} on main thread host.`);return V}if(_(F)){const V=l[F];if(typeof V!="function")throw new Error(`Missing event ${F} on main thread host.`);return V}throw new Error(`Malformed event name ${F}`)}}),this._protocol.setWorkerId(this._worker.getId());let N=null;const A=globalThis.require;typeof A<"u"&&typeof A.getConfig=="function"?N=A.getConfig():typeof globalThis.requirejs<"u"&&(N=globalThis.requirejs.s.contexts._.config);const M=(0,r.getAllMethodNames)(l);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(N)),f,M]);const k=(F,O)=>this._request(F,O),q=(F,O)=>this._protocol.listen(F,O);this._lazyProxy=new Promise((F,O)=>{g=O,this._onModuleLoaded.then(V=>{F(p(V,k,q))},V=>{O(V),this._onError("Worker failed to load "+f,V)})})}getProxyObject(){return this._lazyProxy}_request(a,f){return new Promise((l,g)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,f).then(l,g)},g)})}_onError(a,f){console.error(a),console.info(f)}}n.SimpleWorkerClient=R;function _(o){return o[0]==="o"&&o[1]==="n"&&S.isUpperAsciiLetter(o.charCodeAt(2))}function w(o){return/^onDynamic/.test(o)&&S.isUpperAsciiLetter(o.charCodeAt(9))}function p(o,a,f){const l=A=>function(){const M=Array.prototype.slice.call(arguments,0);return a(A,M)},g=A=>function(M){return f(A,M)},N={};for(const A of o){if(w(A)){N[A]=g(A);continue}if(_(A)){N[A]=f(A,void 0);continue}N[A]=l(A)}return N}class c{constructor(a,f){this._requestHandlerFactory=f,this._requestHandler=null,this._protocol=new C({sendMessage:(l,g)=>{a(l,g)},handleMessage:(l,g)=>this._handleMessage(l,g),handleEvent:(l,g)=>this._handleEvent(l,g)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,f){if(a===d)return this.initialize(f[0],f[1],f[2],f[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,f))}catch(l){return Promise.reject(l)}}_handleEvent(a,f){if(!this._requestHandler)throw new Error("Missing requestHandler");if(w(a)){const l=this._requestHandler[a].call(this._requestHandler,f);if(typeof l!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return l}if(_(a)){const l=this._requestHandler[a];if(typeof l!="function")throw new Error(`Missing event ${a} on request handler.`);return l}throw new Error(`Malformed event name ${a}`)}initialize(a,f,l,g){this._protocol.setWorkerId(a);const M=p(g,(k,q)=>this._protocol.sendMessage(k,q),(k,q)=>this._protocol.listen(k,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve((0,r.getAllMethodNames)(this._requestHandler))):(f&&(typeof f.baseUrl<"u"&&delete f.baseUrl,typeof f.paths<"u"&&typeof f.paths.vs<"u"&&delete f.paths.vs,typeof f.trustedTypesPolicy!==void 0&&delete f.trustedTypesPolicy,f.catchError=!0,globalThis.require.config(f)),new Promise((k,q)=>{(globalThis.require||U)([l],O=>{if(this._requestHandler=O.create(M),!this._requestHandler){q(new Error("No RequestHandler!"));return}k((0,r.getAllMethodNames)(this._requestHandler))},q)}))}}n.SimpleWorkerServer=c;function s(o){return new c(o,null)}n.create=s}),Y(X[54],J([0,1,9,11]),function(U,n,E,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,d){return this._tokenizationSupports.set(S,d),this.handleChange([S]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(S)===d&&(this._tokenizationSupports.delete(S),this.handleChange([S]))})}get(S){return this._tokenizationSupports.get(S)||null}registerFactory(S,d){var u;(u=this._factories.get(S))===null||u===void 0||u.dispose();const y=new r(this,S,d);return this._factories.set(S,y),(0,D.toDisposable)(()=>{const e=this._factories.get(S);!e||e!==y||(this._factories.delete(S),e.dispose())})}getOrCreate(S){return be(this,void 0,void 0,function*(){const d=this.get(S);if(d)return d;const u=this._factories.get(S);return!u||u.isResolved?null:(yield u.resolve(),this.get(S))})}isResolved(S){if(this.get(S))return!0;const u=this._factories.get(S);return!!(!u||u.isResolved)}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class r extends D.Disposable{get isResolved(){return this._isResolved}constructor(S,d,u){super(),this._registry=S,this._languageId=d,this._factory=u,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return be(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return be(this,void 0,void 0,function*(){const S=yield this._factory.tokenizationSupport;this._isResolved=!0,S&&!this._isDisposed&&this._register(this._registry.register(this._languageId,S))})}}}),Y(X[55],J([0,1,32,13,2,54]),function(U,n,E,D,i,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class L{constructor(c,s,o){this.offset=c,this.type=s,this.language=o,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=L;class S{constructor(c,s){this.tokens=c,this.endState=s,this._tokenizationResultBrand=void 0}}n.TokenizationResult=S;class d{constructor(c,s){this.tokens=c,this.endState=s,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=d;var u;(function(p){const c=new Map;c.set(0,E.Codicon.symbolMethod),c.set(1,E.Codicon.symbolFunction),c.set(2,E.Codicon.symbolConstructor),c.set(3,E.Codicon.symbolField),c.set(4,E.Codicon.symbolVariable),c.set(5,E.Codicon.symbolClass),c.set(6,E.Codicon.symbolStruct),c.set(7,E.Codicon.symbolInterface),c.set(8,E.Codicon.symbolModule),c.set(9,E.Codicon.symbolProperty),c.set(10,E.Codicon.symbolEvent),c.set(11,E.Codicon.symbolOperator),c.set(12,E.Codicon.symbolUnit),c.set(13,E.Codicon.symbolValue),c.set(15,E.Codicon.symbolEnum),c.set(14,E.Codicon.symbolConstant),c.set(15,E.Codicon.symbolEnum),c.set(16,E.Codicon.symbolEnumMember),c.set(17,E.Codicon.symbolKeyword),c.set(27,E.Codicon.symbolSnippet),c.set(18,E.Codicon.symbolText),c.set(19,E.Codicon.symbolColor),c.set(20,E.Codicon.symbolFile),c.set(21,E.Codicon.symbolReference),c.set(22,E.Codicon.symbolCustomColor),c.set(23,E.Codicon.symbolFolder),c.set(24,E.Codicon.symbolTypeParameter),c.set(25,E.Codicon.account),c.set(26,E.Codicon.issues);function s(f){let l=c.get(f);return l||(console.info("No codicon found for CompletionItemKind "+f),l=E.Codicon.symbolProperty),l}p.toIcon=s;const o=new Map;o.set("method",0),o.set("function",1),o.set("constructor",2),o.set("field",3),o.set("variable",4),o.set("class",5),o.set("struct",6),o.set("interface",7),o.set("module",8),o.set("property",9),o.set("event",10),o.set("operator",11),o.set("unit",12),o.set("value",13),o.set("constant",14),o.set("enum",15),o.set("enum-member",16),o.set("enumMember",16),o.set("keyword",17),o.set("snippet",27),o.set("text",18),o.set("color",19),o.set("file",20),o.set("reference",21),o.set("customcolor",22),o.set("folder",23),o.set("type-parameter",24),o.set("typeParameter",24),o.set("account",25),o.set("issue",26);function a(f,l){let g=o.get(f);return typeof g>"u"&&!l&&(g=9),g}p.fromString=a})(u=n.CompletionItemKinds||(n.CompletionItemKinds={}));var y;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(y=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));class e{constructor(c,s,o,a){this.range=c,this.text=s,this.completionKind=o,this.isSnippetText=a}equals(c){return i.Range.lift(this.range).equalsRange(c.range)&&this.text===c.text&&this.completionKind===c.completionKind&&this.isSnippetText===c.isSnippetText}}n.SelectedSuggestionInfo=e;var m;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(m=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var h;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(h=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function v(p){return p&&D.URI.isUri(p.uri)&&i.Range.isIRange(p.range)&&(i.Range.isIRange(p.originSelectionRange)||i.Range.isIRange(p.targetSelectionRange))}n.isLocationLink=v;var b;(function(p){const c=new Map;c.set(0,E.Codicon.symbolFile),c.set(1,E.Codicon.symbolModule),c.set(2,E.Codicon.symbolNamespace),c.set(3,E.Codicon.symbolPackage),c.set(4,E.Codicon.symbolClass),c.set(5,E.Codicon.symbolMethod),c.set(6,E.Codicon.symbolProperty),c.set(7,E.Codicon.symbolField),c.set(8,E.Codicon.symbolConstructor),c.set(9,E.Codicon.symbolEnum),c.set(10,E.Codicon.symbolInterface),c.set(11,E.Codicon.symbolFunction),c.set(12,E.Codicon.symbolVariable),c.set(13,E.Codicon.symbolConstant),c.set(14,E.Codicon.symbolString),c.set(15,E.Codicon.symbolNumber),c.set(16,E.Codicon.symbolBoolean),c.set(17,E.Codicon.symbolArray),c.set(18,E.Codicon.symbolObject),c.set(19,E.Codicon.symbolKey),c.set(20,E.Codicon.symbolNull),c.set(21,E.Codicon.symbolEnumMember),c.set(22,E.Codicon.symbolStruct),c.set(23,E.Codicon.symbolEvent),c.set(24,E.Codicon.symbolOperator),c.set(25,E.Codicon.symbolTypeParameter);function s(o){let a=c.get(o);return a||(console.info("No codicon found for SymbolKind "+o),a=E.Codicon.symbolProperty),a}p.toIcon=s})(b=n.SymbolKinds||(n.SymbolKinds={}));class C{static fromValue(c){switch(c){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(c)}constructor(c){this.value=c}}C.Comment=new C("comment"),C.Imports=new C("imports"),C.Region=new C("region"),n.FoldingRangeKind=C;var R;(function(p){function c(s){return!s||typeof s!="object"?!1:typeof s.id=="string"&&typeof s.title=="string"}p.is=c})(R=n.Command||(n.Command={}));var _;(function(p){p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={}));class w{constructor(c){this.createSupport=c,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(c=>{c&&c.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=w,n.TokenizationRegistry=new r.TokenizationRegistry}),Y(X[56],J([0,1,53,9,29,13,3,2,33,55,49]),function(U,n,E,D,i,r,L,S,d,u,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(v,b){return(0,i.KeyChord)(v,b)}}e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,n.KeyMod=e;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:D.Emitter,KeyCode:y.KeyCode,KeyMod:e,Position:L.Position,Range:S.Range,Selection:d.Selection,SelectionDirection:y.SelectionDirection,MarkerSeverity:y.MarkerSeverity,MarkerTag:y.MarkerTag,Uri:r.URI,Token:u.Token}}n.createMonacoBaseAPI=m}),Y(X[59],J([0,1,17,13,3,2,46,22,42,43,56,24,48,41,12]),function(U,n,E,D,i,r,L,S,d,u,y,e,m,h,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class b extends L.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(w){return this._lines[w-1]}getWordAtPosition(w,p){const c=(0,S.getWordAtText)(w.column,(0,S.ensureValidWordDefinition)(p),this._lines[w.lineNumber-1],0);return c?new r.Range(w.lineNumber,c.startColumn,w.lineNumber,c.endColumn):null}words(w){const p=this._lines,c=this._wordenize.bind(this);let s=0,o="",a=0,f=[];return{*[Symbol.iterator](){for(;;)if(a<f.length){const l=o.substring(f[a].start,f[a].end);a+=1,yield l}else if(s<p.length)o=p[s],f=c(o,w),a=0,s+=1;else break}}}getLineWords(w,p){const c=this._lines[w-1],s=this._wordenize(c,p),o=[];for(const a of s)o.push({word:c.substring(a.start,a.end),startColumn:a.start+1,endColumn:a.end+1});return o}_wordenize(w,p){const c=[];let s;for(p.lastIndex=0;(s=p.exec(w))&&s[0].length!==0;)c.push({start:s.index,end:s.index+s[0].length});return c}getValueInRange(w){if(w=this._validateRange(w),w.startLineNumber===w.endLineNumber)return this._lines[w.startLineNumber-1].substring(w.startColumn-1,w.endColumn-1);const p=this._eol,c=w.startLineNumber-1,s=w.endLineNumber-1,o=[];o.push(this._lines[c].substring(w.startColumn-1));for(let a=c+1;a<s;a++)o.push(this._lines[a]);return o.push(this._lines[s].substring(0,w.endColumn-1)),o.join(p)}offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.lineNumber-2)+(w.column-1)}positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(w),c=this._lines[p.index].length;return{lineNumber:1+p.index,column:1+Math.min(p.remainder,c)}}_validateRange(w){const p=this._validatePosition({lineNumber:w.startLineNumber,column:w.startColumn}),c=this._validatePosition({lineNumber:w.endLineNumber,column:w.endColumn});return p.lineNumber!==w.startLineNumber||p.column!==w.startColumn||c.lineNumber!==w.endLineNumber||c.column!==w.endColumn?{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:c.lineNumber,endColumn:c.column}:w}_validatePosition(w){if(!i.Position.isIPosition(w))throw new Error("bad position");let{lineNumber:p,column:c}=w,s=!1;if(p<1)p=1,c=1,s=!0;else if(p>this._lines.length)p=this._lines.length,c=this._lines[p-1].length+1,s=!0;else{const o=this._lines[p-1].length+1;c<1?(c=1,s=!0):c>o&&(c=o,s=!0)}return s?{lineNumber:p,column:c}:w}}class C{constructor(w,p){this._host=w,this._models=Object.create(null),this._foreignModuleFactory=p,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(w){return this._models[w]}_getModels(){const w=[];return Object.keys(this._models).forEach(p=>w.push(this._models[p])),w}acceptNewModel(w){this._models[w.url]=new b(D.URI.parse(w.url),w.lines,w.EOL,w.versionId)}acceptModelChanged(w,p){if(!this._models[w])return;this._models[w].onEvents(p)}acceptRemovedModel(w){this._models[w]&&delete this._models[w]}computeUnicodeHighlights(w,p,c){return be(this,void 0,void 0,function*(){const s=this._getModel(w);return s?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(s,p,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(w,p,c,s){return be(this,void 0,void 0,function*(){const o=this._getModel(w),a=this._getModel(p);return!o||!a?null:C.computeDiff(o,a,c,s)})}static computeDiff(w,p,c,s){const o=s==="experimental"?h.linesDiffComputers.experimental:h.linesDiffComputers.smart,a=w.getLinesContent(),f=p.getLinesContent(),l=o.computeDiff(a,f,c);return{identical:l.changes.length>0?!1:this._modelsAreIdentical(w,p),quitEarly:l.hitTimeout,changes:l.changes.map(N=>{var A;return[N.originalRange.startLineNumber,N.originalRange.endLineNumberExclusive,N.modifiedRange.startLineNumber,N.modifiedRange.endLineNumberExclusive,(A=N.innerChanges)===null||A===void 0?void 0:A.map(M=>[M.originalRange.startLineNumber,M.originalRange.startColumn,M.originalRange.endLineNumber,M.originalRange.endColumn,M.modifiedRange.startLineNumber,M.modifiedRange.startColumn,M.modifiedRange.endLineNumber,M.modifiedRange.endColumn])]})}}static _modelsAreIdentical(w,p){const c=w.getLineCount(),s=p.getLineCount();if(c!==s)return!1;for(let o=1;o<=c;o++){const a=w.getLineContent(o),f=p.getLineContent(o);if(a!==f)return!1}return!0}computeMoreMinimalEdits(w,p,c){return be(this,void 0,void 0,function*(){const s=this._getModel(w);if(!s)return p;const o=[];let a;p=p.slice(0).sort((f,l)=>{if(f.range&&l.range)return r.Range.compareRangesUsingStarts(f.range,l.range);const g=f.range?0:1,N=l.range?0:1;return g-N});for(let{range:f,text:l,eol:g}of p){if(typeof g=="number"&&(a=g),r.Range.isEmpty(f)&&!l)continue;const N=s.getValueInRange(f);if(l=l.replace(/\r\n|\n|\r/g,s.eol),N===l)continue;if(Math.max(l.length,N.length)>C._diffLimit){o.push({range:f,text:l});continue}const A=(0,E.stringDiff)(N,l,c),M=s.offsetAt(r.Range.lift(f).getStartPosition());for(const k of A){const q=s.positionAt(M+k.originalStart),F=s.positionAt(M+k.originalStart+k.originalLength),O={text:l.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:F.lineNumber,endColumn:F.column}};s.getValueInRange(O.range)!==O.text&&o.push(O)}}return typeof a=="number"&&o.push({eol:a,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),o})}computeLinks(w){return be(this,void 0,void 0,function*(){const p=this._getModel(w);return p?(0,d.computeLinks)(p):null})}textualSuggest(w,p,c,s){return be(this,void 0,void 0,function*(){const o=new e.StopWatch(!0),a=new RegExp(c,s),f=new Set;e:for(const l of w){const g=this._getModel(l);if(g){for(const N of g.words(a))if(!(N===p||!isNaN(Number(N)))&&(f.add(N),f.size>C._suggestionsLimit))break e}}return{words:Array.from(f),duration:o.elapsed()}})}computeWordRanges(w,p,c,s){return be(this,void 0,void 0,function*(){const o=this._getModel(w);if(!o)return Object.create(null);const a=new RegExp(c,s),f=Object.create(null);for(let l=p.startLineNumber;l<p.endLineNumber;l++){const g=o.getLineWords(l,a);for(const N of g){if(!isNaN(Number(N.word)))continue;let A=f[N.word];A||(A=[],f[N.word]=A),A.push({startLineNumber:l,startColumn:N.startColumn,endLineNumber:l,endColumn:N.endColumn})}}return f})}navigateValueSet(w,p,c,s,o){return be(this,void 0,void 0,function*(){const a=this._getModel(w);if(!a)return null;const f=new RegExp(s,o);p.startColumn===p.endColumn&&(p={startLineNumber:p.startLineNumber,startColumn:p.startColumn,endLineNumber:p.endLineNumber,endColumn:p.endColumn+1});const l=a.getValueInRange(p),g=a.getWordAtPosition({lineNumber:p.startLineNumber,column:p.startColumn},f);if(!g)return null;const N=a.getValueInRange(g);return u.BasicInplaceReplace.INSTANCE.navigateValueSet(p,l,g,N,c)})}loadForeignModule(w,p,c){const s=(f,l)=>this._host.fhr(f,l),a={host:(0,v.createProxyObject)(c,s),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(a,p),Promise.resolve((0,v.getAllMethodNames)(this._foreignModule))):new Promise((f,l)=>{U([w],g=>{this._foreignModule=g.create(a,p),f((0,v.getAllMethodNames)(this._foreignModule))},l)})}fmr(w,p){if(!this._foreignModule||typeof this._foreignModule[w]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+w));try{return Promise.resolve(this._foreignModule[w].apply(this._foreignModule,p))}catch(c){return Promise.reject(c)}}}C._diffLimit=1e5,C._suggestionsLimit=1e4,n.EditorSimpleWorker=C;function R(_){return new C(_,null)}n.create=R,typeof importScripts=="function"&&(globalThis.monaco=(0,y.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map